"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShardusTypes = exports.logDir_global = void 0;
const P2PTypes_1 = require("@shardeum-foundation/lib-types/build/src/p2p/P2PTypes");
const events_1 = require("events");
const path_1 = __importDefault(require("path"));
const util_1 = require("util");
const config_1 = __importDefault(require("../config"));
const crypto_1 = __importDefault(require("../crypto"));
const debug_1 = __importStar(require("../debug"));
const exit_handler_1 = __importDefault(require("../exit-handler"));
const load_detection_1 = __importDefault(require("../load-detection"));
const logger_1 = __importStar(require("../logger"));
const Network = __importStar(require("../network"));
const debugMiddleware_1 = require("../network/debugMiddleware");
const Apoptosis_1 = require("../p2p/Apoptosis");
const Archivers = __importStar(require("../p2p/Archivers"));
const Context = __importStar(require("../p2p/Context"));
const Context_1 = require("../p2p/Context");
const AutoScaling = __importStar(require("../p2p/CycleAutoScale"));
const CycleChain = __importStar(require("../p2p/CycleChain"));
const CycleCreator = __importStar(require("../p2p/CycleCreator"));
const CycleCreator_1 = require("../p2p/CycleCreator");
const GlobalAccounts = __importStar(require("../p2p/GlobalAccounts"));
const ServiceQueue = __importStar(require("../p2p/ServiceQueue"));
const Lost_1 = require("../p2p/Lost");
const NodeList_1 = require("../p2p/NodeList");
const Self = __importStar(require("../p2p/Self"));
const Wrapper = __importStar(require("../p2p/Wrapper"));
const rate_limiting_1 = __importDefault(require("../rate-limiting"));
const reporter_1 = __importDefault(require("../reporter"));
const ShardusTypes = __importStar(require("../shardus/shardus-types"));
const Snapshot = __importStar(require("../snapshot"));
const state_manager_1 = __importDefault(require("../state-manager"));
const TransactionQueue_1 = require("../state-manager/TransactionQueue");
const statistics_1 = __importDefault(require("../statistics"));
const storage_1 = __importDefault(require("../storage"));
const Helpers_1 = require("../types/ajv/Helpers");
const utils = __importStar(require("../utils"));
const utils_1 = require("../utils");
const debugUtils_1 = require("../utils/debugUtils");
const memoryReporting_1 = __importDefault(require("../utils/memoryReporting"));
const nestedCounters_1 = require("../utils/nestedCounters");
const profiler_1 = __importStar(require("../utils/profiler"));
const saveConsoleOutput_1 = require("./saveConsoleOutput");
const debug_2 = require("../debug");
const JoinV2 = __importStar(require("../p2p/Join/v2"));
const network_1 = require("../network");
const Modes_1 = require("../p2p/Modes");
const state_1 = require("../p2p/LostArchivers/state");
const getCallstack_1 = __importDefault(require("../utils/getCallstack"));
const crypto = __importStar(require("@shardeum-foundation/lib-crypto-utils"));
const Comms = __importStar(require("./../p2p/Comms"));
const InternalRouteEnum_1 = require("../types/enum/InternalRouteEnum");
const RequestErrorEnum_1 = require("../types/enum/RequestErrorEnum");
const Helpers_2 = require("../types/Helpers");
const TypeIdentifierEnum_1 = require("../types/enum/TypeIdentifierEnum");
const SignAppDataReq_1 = require("../types/SignAppDataReq");
const SignAppDataResp_1 = require("../types/SignAppDataResp");
const lib_types_1 = require("@shardeum-foundation/lib-types");
const Utils_1 = require("../p2p/Utils");
const shardFunctions_1 = __importDefault(require("../state-manager/shardFunctions"));
const Join_1 = require("../p2p/Join");
const NodeList = __importStar(require("../p2p/NodeList"));
const lib_types_2 = require("@shardeum-foundation/lib-types");
const csvPerfEvents = __importStar(require("./../logger/csvPerfEvents"));
const AJVSchemaEnum_1 = require("../types/enum/AJVSchemaEnum");
// the following can be removed now since we are not using the old p2p code
//const P2P = require('../p2p')
const allZeroes64 = '0'.repeat(64);
const defaultConfigs = config_1.default;
Context.setDefaultConfigs(defaultConfigs);
//todo make this a config parameter set by the dapp
const changeListGlobalAccount = defaultConfigs.server.globalAccount;
/**
 * The main module that is used by the app developer to interact with the shardus api
 */
class Shardus extends events_1.EventEmitter {
    constructor({ server: config, logs: logsConfig, storage: storageConfig }) {
        super();
        this.addNetworkTx = ServiceQueue.addNetworkTx;
        this.getLatestNetworkTxEntryForSubqueueKey = ServiceQueue.getLatestNetworkTxEntryForSubqueueKey;
        this.debugForeverLoopsEnabled = true;
        this.debugForeverLoopCounter = 0;
        this.nestedCounters = nestedCounters_1.nestedCountersInstance;
        this.memoryReporting = new memoryReporting_1.default(this);
        this.config = config;
        Context.setConfig(this.config);
        this.profiler = new profiler_1.default();
        logger_1.logFlags.verbose = false;
        let startInFatalsLogMode = config && config.debug && config.debug.startInFatalsLogMode ? true : false;
        let startInErrorsLogMode = config && config.debug && config.debug.startInErrorLogMode ? true : false;
        let dynamicLogMode = '';
        if (startInFatalsLogMode === true) {
            dynamicLogMode = 'fatal';
        }
        else if (startInErrorsLogMode === true) {
            dynamicLogMode = 'error';
        }
        (0, Helpers_1.initAjvSchemas)();
        this.logger = new logger_1.default(config.baseDir, logsConfig, dynamicLogMode);
        Context.setLoggerContext(this.logger);
        Snapshot.initLogger();
        const logDir = path_1.default.join(config.baseDir, logsConfig.dir);
        exports.logDir_global = logDir;
        if (logsConfig.saveConsoleOutput) {
            (0, saveConsoleOutput_1.startSaving)(logDir);
        }
        this.mainLogger = this.logger.getLogger('main');
        this.seqLogger = this.logger.getLogger('seq');
        this.fatalLogger = this.logger.getLogger('fatal');
        this.appLogger = this.logger.getLogger('app');
        this.exitHandler = new exit_handler_1.default(logDir, this.memoryReporting, this.nestedCounters);
        this.storage = new storage_1.default(config.baseDir, storageConfig, config, this.logger, this.profiler);
        Context.setStorageContext(this.storage);
        this.crypto = new crypto_1.default(config.baseDir, this.config, this.logger, this.storage);
        Context.setCryptoContext(this.crypto);
        this.network = new Network.NetworkClass(config, this.logger);
        Context.setNetworkContext(this.network);
        // Set the old P2P to a Wrapper into the new P2P
        // [TODO] Remove this once everything calls p2p/* modules directly
        this.p2p = Wrapper.p2p;
        Context.setP2pContext(this.p2p);
        this.debug = null;
        this.appProvided = null;
        this.app = null;
        this.reporter = null;
        this.stateManager = null;
        this.statistics = null;
        this.loadDetection = null;
        this.rateLimiting = null;
        this.appliedConfigChanges = new Set();
        if (logger_1.logFlags.info) {
            this.mainLogger.info(`Server started with pid: ${process.pid}`);
            this.mainLogger.info('===== Server config: =====');
            this.mainLogger.info(JSON.stringify(config, null, 2));
        }
        // error log and console log on unacceptable minNodesToAllowTxs value
        // if (this.config.p2p.minNodesToAllowTxs < 20) {
        //   const minNodesToAllowTxs = this.config.p2p.minNodesToAllowTxs
        //   // debug mode and detected non-ideal value
        //   console.log(
        //     '[X] Minimum node required to allow transaction is set to a number less than 20 which is not ideal and secure for production'
        //   )
        //   if (this.config.mode === 'debug' && logFlags.error) {
        //     this.mainLogger.error(
        //       `Unacceptable \`minNodesToAllowTxs\` value detected: ${minNodesToAllowTxs} (< 20)`
        //     )
        //   }
        //   // production mode and detected non-ideal value
        //   else if (this.config.mode !== 'debug' && logFlags.error) {
        //     this.mainLogger.error(
        //       `Unacceptable \`minNodesToAllowTxs\` value detected: ${minNodesToAllowTxs} (< 20)`
        //     )
        //   }
        //   // for now they'd have the same error log
        //   // this is not as error per technical definition rather logical error
        // }
        this._listeners = {};
        this.heartbeatInterval = config.heartbeatInterval;
        this.heartbeatTimer = null;
        // alias the network register calls so that an app can get to them
        this.registerExternalGet = (route, authHandler, handler) => this.network.registerExternalGet(route, authHandler, handler);
        this.registerExternalPost = (route, authHandler, handler) => this.network.registerExternalPost(route, authHandler, handler);
        this.registerExternalPut = (route, authHandler, handler) => this.network.registerExternalPut(route, authHandler, handler);
        this.registerExternalDelete = (route, authHandler, handler) => this.network.registerExternalDelete(route, authHandler, handler);
        this.registerExternalPatch = (route, authHandler, handler) => this.network.registerExternalPatch(route, authHandler, handler);
        // serviceQueue module
        this.serviceQueue = {
            registerBeforeAddVerifier: ServiceQueue.registerBeforeAddVerifier,
            registerApplyVerifier: ServiceQueue.registerApplyVerifier,
            registerShutdownHandler: ServiceQueue.registerShutdownHandler,
            containsTxData: ServiceQueue.containsTxData,
            containsTx: ServiceQueue.containsTx,
            addNetworkTx: ServiceQueue.addNetworkTx,
            getLatestNetworkTxEntryForSubqueueKey: ServiceQueue.getLatestNetworkTxEntryForSubqueueKey
        };
        this.exitHandler.addSigListeners();
        this.exitHandler.registerSync('reporter', () => {
            if (this.reporter) {
                this.mainLogger.info('Stopping reporter...');
                this.reporter.stopReporting();
            }
        });
        this.exitHandler.registerAsync('application', async () => {
            if (this.app && this.app.close) {
                this.mainLogger.info('Shutting down the application...');
                await this.app.close(); // this needs to be awaited since it is async
            }
        });
        this.exitHandler.registerSync('crypto', () => {
            this.mainLogger.info('Stopping POW generators...');
            this.crypto.stopAllGenerators();
        });
        this.exitHandler.registerSync('cycleCreator', () => {
            // [TODO] - need to make an exitHandler for P2P; otherwise CycleCreator is continuing even after rest of the system cleans up and is ready to exit
            this.mainLogger.info('Shutting down p2p...');
            this.p2p.shutdown();
        });
        this.exitHandler.registerAsync('network', async () => {
            this.mainLogger.info('Shutting down networking...');
            await this.network.shutdown(); // this is taking a long time
        });
        this.exitHandler.registerAsync('storage', async () => {
            this.mainLogger.info('Closing Database connections...');
            await this.storage.close();
        });
        this.exitHandler.registerAsync('unjoin', async () => {
            if (Modes_1.networkMode !== 'shutdown') {
                this.mainLogger.info('Submitting unjoin request...');
                await JoinV2.shutdown();
            }
        });
        /* moved stopping the application to earlier
        this.exitHandler.registerAsync('application', async () => {
          if (this.app && this.app.close) {
            this.mainLogger.info('Shutting down the application...')
            await this.app.close()  // this needs to be awaited since it is async
          }
        })
        */
        this.exitHandler.registerAsync('logger', async () => {
            this.mainLogger.info('Shutting down logs...');
            await this.logger.shutdown();
            csvPerfEvents.writeBufferToCSV();
        });
        this.profiler.registerEndpoints();
        this.nestedCounters.registerEndpoints();
        this.memoryReporting.registerEndpoints();
        this.logger.registerEndpoints(Context);
        this.logger.playbackLogState('constructed', '', '');
    }
    /**
     * This function is what the app developer uses to setup all the SDK functions used by shardus
     * @typedef {import('./index').App} App
     */
    setup(app) {
        if (app === null) {
            this.appProvided = false;
        }
        else if (app === Object(app)) {
            this.app = this._getApplicationInterface(app);
            this.appProvided = true;
            this.logger.playbackLogState('appProvided', '', '');
        }
        else {
            throw new Error('Please provide an App object or null to Shardus.setup.');
        }
        return this;
    }
    /**
     * Calling this function will start the network
     * @param {*} exitProcOnFail Exit the process if an error occurs
     */
    // async start_OLD (exitProcOnFail = true) {
    //   if (this.appProvided === null) throw new Error('Please call Shardus.setup with an App object or null before calling Shardus.start.')
    //   await this.storage.init()
    //   this._setupHeartbeat()
    //   this.crypto = new Crypto(this.config, this.logger, this.storage)
    //   Context.setCryptoContext(this.crypto)
    //   await this.crypto.init()
    //   const ipInfo = this.config.ip
    //   const p2pConf = Object.assign({ ipInfo }, this.config.p2p)
    //   this.p2p = new P2P(p2pConf, this.logger, this.storage, this.crypto)
    //   Context.setP2pContext(this.p2p)
    //   await this.p2p.init(this.network)
    //   this.debug = new Debug(this.config.baseDir, this.network)
    //   this.debug.addToArchive(this.logger.logDir, './logs')
    //   this.debug.addToArchive(path.parse(this.storage.storage.storageConfig.options.storage).dir, './db')
    //   this.statistics = new Statistics(this.config.baseDir, this.config.statistics, {
    //     counters: ['txInjected', 'txApplied', 'txRejected', 'txExpired', 'txProcessed'],
    //     watchers: {
    //       queueLength: () => this.stateManager ? this.stateManager.transactionQueue.newAcceptedTxQueue.length : 0,
    //       serverLoad: () => this.loadDetection ? this.loadDetection.getCurrentLoad() : 0
    //     },
    //     timers: ['txTimeInQueue']
    //   }, this)
    //   this.debug.addToArchive('./statistics.tsv', './statistics.tsv')
    //   this.loadDetection = new LoadDetection(this.config.loadDetection, this.statistics)
    //   this.statistics.on('snapshot', () => this.loadDetection.updateLoad())
    //   this.loadDetection.on('highLoad', async () => {
    //     await this.p2p.requestNetworkUpsize()
    //   })
    //   this.loadDetection.on('lowLoad', async () => {
    //     await this.p2p.requestNetworkDownsize()
    //   })
    //   this.rateLimiting = new RateLimiting(this.config.rateLimiting, this.loadDetection)
    //   this.consensus = new Consensus(this.app, this.config, this.logger, this.crypto, this.p2p, this.storage, this.profiler)
    //   if (this.app) {
    //     this._createAndLinkStateManager()
    //     this._attemptCreateAppliedListener()
    //   }
    //   this.reporter = this.config.reporting.report ? new Reporter(this.config.reporting, this.logger, this.p2p, this.statistics, this.stateManager, this.profiler, this.loadDetection) : null
    //   this._registerRoutes()
    //   this.p2p.on('joining', (publicKey) => {
    //     this.logger.playbackLogState('joining', '', publicKey)
    //     if (this.reporter) this.reporter.reportJoining(publicKey)
    //   })
    //   this.p2p.on('joined', (nodeId, publicKey) => {
    //     this.logger.playbackLogState('joined', nodeId, publicKey)
    //     this.logger.setPlaybackID(nodeId)
    //     if (this.reporter) this.reporter.reportJoined(nodeId, publicKey)
    //   })
    //   this.p2p.on('initialized', async () => {
    //     await this.syncAppData()
    //     this.p2p.goActive()
    //   })
    //   this.p2p.on('active', (nodeId) => {
    //     this.logger.playbackLogState('active', nodeId, '')
    //     if (this.reporter) {
    //       this.reporter.reportActive(nodeId)
    //       this.reporter.startReporting()
    //     }
    //     if (this.statistics) this.statistics.startSnapshots()
    //     this.emit('active', nodeId)
    //   })
    //   this.p2p.on('failed', () => {
    //     this.shutdown(exitProcOnFail)
    //   })
    //   this.p2p.on('error', (e) => {
    //     console.log(e.message + ' at ' + e.stack)
    //     this.mainLogger.debug('shardus.start() ' + e.message + ' at ' + e.stack)
    //     this.fatalLogger.fatal('shardus.start() ' + e.message + ' at ' + e.stack)
    //     throw new Error(e)
    //   })
    //   this.p2p.on('removed', async () => {
    //     if (this.statistics) {
    //       this.statistics.stopSnapshots()
    //       this.statistics.initialize()
    //     }
    //     if (this.reporter) {
    //       this.reporter.stopReporting()
    //       await this.reporter.reportRemoved(this.p2p.id)
    //     }
    //     if (this.app) {
    //       await this.app.deleteLocalAccountData()
    //       this._attemptRemoveAppliedListener()
    //       this._unlinkStateManager()
    //       await this.stateManager.cleanup()
    //       // Dont start a new state manager. pm2 will do a full restart if needed.
    //       // this._createAndLinkStateManager()
    //       // this._attemptCreateAppliedListener()
    //     }
    //     await this.p2p.restart()
    //   })
    //   Context.setShardusContext(this)
    //   await Self.init(this.config)
    //   await Self.startup()
    // }
    async start() {
        // Check network up & time synced
        await Network.init();
        const isInTimeLimit = await Network.checkAndUpdateTimeSyncedOffset(this.config.p2p.timeServers);
        if (isInTimeLimit === false) {
            this.mainLogger.error(`Time is not in sync with the network from checkAndUpdateTimeSyncedOffset process`);
            throw new Error(`Time is not in sync with the network during ntpOffsetMs generation`);
        }
        if (!(0, debug_2.isServiceMode)()) {
            // Setup storage
            await this.storage.init();
        }
        // Setup crypto
        await this.crypto.init();
        try {
            const sk = this.crypto.keypair.secretKey;
            this.io = (await this.network.setup(Network.ipInfo, sk));
            Context.setIOContext(this.io);
            /*
              * The old middleware is deleted and repurpose into a function
              * It was causing problem because as nature of middlewares are expected to run in each events.
              *   But the authentication payload is only needed to be checked and only supplied once at the socket.io handshake
              *   This caused the archiver to be able to connect on the first handshake stuck.
              *   redundant crypto.verify calls were made.
              */
            function validateSocketHandshake(socket, crypto, mainLogger) {
                // `this` is not binded
                // calling `this` in the function will not be the same `this` as the outer LOC were referencing to
                try {
                    if (!Self || !Self.isActive) {
                        if (!Self.allowConnectionToFirstNode) {
                            mainLogger.error(`❌ This node is not active yet and kill the socket connection!`);
                            return false;
                        }
                    }
                    // Check if the archiver module is initialized; this is unlikely to happen because of the above Self.isActive check
                    if (!Archivers.recipients || !Archivers.connectedSockets) {
                        mainLogger.error(`❌ Seems Archiver module isn't initialized yet, dropping the Socket connection!`);
                        return false;
                    }
                    nestedCounters_1.nestedCountersInstance.countEvent('debug-archiverConnections', `ourIP: ${Self.ip}`);
                    nestedCounters_1.nestedCountersInstance.countEvent('debug-archiverConnections', `socket.handshake.address: ${socket.handshake.address.split('::ffff:').pop()}`);
                    nestedCounters_1.nestedCountersInstance.countEvent('debug-archiverConnections', `socket.handshake.headers.host: ${socket.handshake.headers.host.split(':')[0]}`);
                    // And we've encountered issues with it in the earthnet
                    // Plus the archiver is already authenticated by the signature.
                    // Singature valid and ip are not in sync? then we got a bigger problem to worry about.
                    // const archiverIP = socket.handshake.address.split('::ffff:').pop();
                    // if (!utils.isValidIPv4(archiverIP)) {
                    //   mainLogger.error(`❌ Invalid IP-Address of Archiver: ${archiverIP}`)
                    //   return false
                    // }
                    const archiverCreds = JSON.parse(socket.handshake.query.data);
                    // +/- 5sec tolerance
                    if (Math.abs(archiverCreds.timestamp - (0, network_1.shardusGetTime)()) > 5000) {
                        mainLogger.error(`❌ Old signature from Archiver @ ${archiverCreds.publicKey}`);
                        return false;
                    }
                    if (archiverCreds.intendedConsensor !== Self.getThisNodeInfo().publicKey) {
                        mainLogger.error(`❌ The signature is targeted for consensor @ ${archiverCreds.intendedConsensor} but this node is ${Self.getThisNodeInfo().publicKey}`);
                        return false;
                    }
                    const isValidSig = crypto.verify(archiverCreds, archiverCreds.publicKey);
                    if (!isValidSig) {
                        mainLogger.error(`❌ Invalid Signature from Archiver @ ${archiverCreds.publicKey}`);
                        return false;
                    }
                    if (Object.keys(Archivers.connectedSockets).length >= Context_1.config.p2p.maxArchiversSubscriptionPerNode) {
                        /* prettier-ignore */ console.log(`There are already ${Context_1.config.p2p.maxArchiversSubscriptionPerNode} archivers connected for data transfer!`);
                        return false;
                    }
                    // we're the genesis node, this mean cycle is empty, archiver list is empty
                    // nothing to check against.
                    // In practice genesis node is accompanied with a genesis archiver by the same party at launch
                    // so this is ok.
                    if (Self && Self.isFirst)
                        return true;
                    // specifically this map here to get archiver list is chose because the map is populated by cycle parsing.
                    // The one like `recipients` map is weaker because they're populated at joinReq
                    const archiver = Archivers.archivers.get(archiverCreds.publicKey);
                    // bypass this check when this is genesis node
                    if (!archiver) {
                        mainLogger.error(`❌ Remote Archiver @ ${archiver.publicKey} is NOT recognized!`);
                        return false;
                    }
                    // The ip check is known to have issues with NATs and other network setups.
                    // And we've encountered issues with it in the earthnet
                    // Plus the archiver is already authenticated by the signature.
                    // Singature valid and ip are not in sync? then we got a bigger problem to worry about.
                    // if (archiverIP !== archiver.ip) {
                    //   mainLogger.error(`❌ PubKey & IP mismatch for Archiver @ ${archiverIP} !`)
                    //   mainLogger.error('Recipient: ', archiver.ip)
                    //   mainLogger.error('Remote Archiver: ', socket.handshake.address)
                    //   return false
                    // }
                    return true;
                }
                catch (error) {
                    mainLogger.error('❌ Error in Archiver Socket-Connection Auth!');
                    mainLogger.error(error);
                    return false;
                }
            }
            this.io.on('connection', (socket) => {
                if (!validateSocketHandshake(socket, this.crypto, this.mainLogger)) {
                    socket.disconnect();
                    return;
                }
                const { publicKey: archiverPublicKey } = JSON.parse(socket.handshake.query.data);
                console.log(`✅ Archive server has subscribed to this node with Socket-ID ${socket.id}!`);
                console.log('Archiver has registered its public key', archiverPublicKey);
                // prototype pollution mitigation
                // best case is to use the Map<>
                // going with local fix atm. Deep copy, freeze. read-only. 
                let freezedList = Object.freeze(JSON.parse(JSON.stringify(Archivers.connectedSockets)));
                // The same archiver is connected with different stream, let's disconnect old and accept the current one.
                if (freezedList[archiverPublicKey]) {
                    Archivers.removeArchiverConnection(archiverPublicKey);
                }
                Archivers.addArchiverConnection(archiverPublicKey, socket.id);
                socket.on('UNSUBSCRIBE', function (ARCHIVER_PUBLIC_KEY) {
                    if (freezedList[ARCHIVER_PUBLIC_KEY] === socket.id) {
                        console.log(`Archive server with public key ${ARCHIVER_PUBLIC_KEY} has requested to Un-subscribe`);
                        Archivers.removeArchiverConnection(ARCHIVER_PUBLIC_KEY);
                    }
                });
            });
        }
        catch (e) {
            this.mainLogger.error('Socket connection break', e);
        }
        this.network.on('timeout', (node, requestId, context, route) => {
            const ipPort = `${node.internalIp}:${node.internalPort}`;
            //this console log is probably redundant but are disabled most of the time anyhow.
            //They may help slighly in the case of adding some context to the out.log file when full debugging is on.
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                console.log(`In Shardus got network timeout-${context}-${route} for request ID - ${requestId} from node: ${utils.logNode(node)} ${ipPort}`);
            const result = (0, Apoptosis_1.isApopMarkedNode)(node.id);
            if (result) {
                /* prettier-ignore */ nestedCounters_1.nestedCountersInstance.countEvent('lostNodes', `timeout-apop-${context}-${route}`);
                return;
            }
            if (!Context_1.config.debug.disableLostNodeReports)
                (0, Lost_1.scheduleLostReport)(node, 'timeout', requestId);
            /** [TODO] Report lost */
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                nestedCounters_1.nestedCountersInstance.countEvent('lostNodes', `timeout-${context}`);
            // context has been added to provide info on the type of timeout and where it happened
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                nestedCounters_1.nestedCountersInstance.countRareEvent('lostNodes', `timeout-${context}  ${ipPort}`);
            if (this.network.statisticsInstance)
                this.network.statisticsInstance.incrementCounter('lostNodeTimeout');
        });
        this.network.on('error', (node, requestId, context, errorGroup, route, subRoute = '') => {
            const ipPort = `${node.internalIp}:${node.internalPort}`;
            //this console log is probably redundant but are disabled most of the time anyhow.
            //They may help slighly in the case of adding some context to the out.log file when full debugging is on.
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                console.log(`In Shardus got network error-${context} ${route}-${subRoute} for request ID ${requestId} from node: ${utils.logNode(node)} ${ipPort} error:${errorGroup}`);
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                console.log(`node:`, node);
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal)
                console.log(`requestId: ${requestId}, context: ${context}, route: ${route}, subRoute: ${subRoute}, errorGroup: ${errorGroup}`);
            if (!Context_1.config.debug.disableLostNodeReports)
                (0, Lost_1.scheduleLostReport)(node, 'error', requestId);
            /** [TODO] Report lost */
            /* prettier-ignore */ nestedCounters_1.nestedCountersInstance.countEvent('lostNodes', `error-${context}-${route}-${subRoute}`);
            /* prettier-ignore */ nestedCounters_1.nestedCountersInstance.countRareEvent('lostNodes', `error-${context}  ${ipPort}`);
        });
        // Setup other modules
        this.debug = new debug_1.default(this.config.baseDir, this.network);
        this.debug.addToArchive(this.logger.logDir, './logs');
        this.debug.addToArchive(path_1.default.parse(this.storage.storage.storageConfig.options.storage).dir, './db');
        if (!(0, debug_2.isServiceMode)()) {
            this.statistics = new statistics_1.default(this.config.baseDir, this.config.statistics, {
                counters: [
                    'txInjected',
                    'txApplied',
                    'txRejected',
                    'txExpired',
                    'txProcessed',
                    'networkTimeout',
                    'lostNodeTimeout',
                ],
                watchers: {
                    queueLength: () => this.stateManager ? this.stateManager.transactionQueue._transactionQueue.length : 0,
                    executeQueueLength: () => this.stateManager ? this.stateManager.transactionQueue.getExecuteQueueLength() : 0,
                    serverLoad: () => (this.loadDetection ? this.loadDetection.getCurrentLoad() : 0),
                },
                timers: ['txTimeInQueue'],
                manualStats: ['netInternalDuty', 'netExternalDuty'],
                fifoStats: ['cpuPercent'],
                ringOverrides: {},
                fifoOverrides: { cpuPercent: 240 },
            }, this);
        }
        this.debug.addToArchive('./statistics.tsv', './statistics.tsv');
        this.profiler.setStatisticsInstance(this.statistics);
        this.network.setStatisticsInstance(this.statistics);
        this.statistics;
        this.loadDetection = new load_detection_1.default(this.config.loadDetection, this.statistics);
        this.loadDetection.on('highLoad', () => {
            // console.log(`High load detected Cycle ${currentCycle}, Quarter: ${currentQuarter}`)
            nestedCounters_1.nestedCountersInstance.countEvent('loadRelated', 'highLoad');
            AutoScaling.requestNetworkUpsize();
        });
        this.loadDetection.on('lowLoad', () => {
            // console.log(`Low load detected Cycle ${currentCycle}, Quarter: ${currentQuarter}`)
            nestedCounters_1.nestedCountersInstance.countEvent('loadRelated', 'lowLoad');
            AutoScaling.requestNetworkDownsize();
        });
        if (!(0, debug_2.isServiceMode)())
            this.statistics.on('snapshot', () => this.loadDetection.updateLoad());
        this.rateLimiting = new rate_limiting_1.default(this.config.rateLimiting, this.seqLogger);
        Context.setShardusContext(this);
        // Init new P2P
        Self.init();
        if (this.app) {
            this._createAndLinkStateManager();
            this._attemptCreateAppliedListener();
            let disableSnapshots = !!(this.config &&
                this.config.debug &&
                this.config.debug.disableSnapshots === true);
            if (disableSnapshots != true) {
                // Start state snapshotting once you go active with an app
                this.once('active', Snapshot.startSnapshotting);
            }
        }
        this.reporter =
            this.config.reporting.report && !(0, debug_2.isServiceMode)()
                ? new reporter_1.default(this.config.reporting, this.logger, this.statistics, this.stateManager, this.profiler, this.loadDetection)
                : null;
        Context.setReporterContext(this.reporter);
        this._registerRoutes();
        // this.io.on('disconnect')
        // Register listeners for P2P events
        Self.emitter.on('witnessing', async (publicKey) => {
            this.logger.playbackLogState('witnessing', '', publicKey);
            await Snapshot.startWitnessMode();
        });
        Self.emitter.on('joining', (publicKey) => {
            // this.io.emit('DATA', `NODE JOINING ${publicKey}`)
            this.logger.playbackLogState('joining', '', publicKey);
            if (this.reporter)
                this.reporter.reportJoining(publicKey);
        });
        Self.emitter.on('joined', (nodeId, publicKey) => {
            // this.io.emit('DATA', `NODE JOINED ${nodeId}`)
            this.logger.playbackLogState('joined', nodeId, publicKey);
            this.logger.setPlaybackID(nodeId);
            if (this.reporter)
                this.reporter.reportJoined(nodeId, publicKey);
        });
        Self.emitter.on('initialized', async () => {
            // If network is in safety mode
            const newest = CycleChain.getNewest();
            // changed from using safetyMode to mode
            if (newest && (newest.mode === 'restart' || newest.mode === 'recovery')) {
                // Stay in syncing mode and let other nodes join
                Self.setp2pIgnoreJoinRequests(false);
                console.log('p2pIgnoreJoinRequests = false');
                nestedCounters_1.nestedCountersInstance.countEvent('restore', `intialized: ${newest.mode}. ${(0, network_1.shardusGetTime)()}`);
            }
            else {
                // not doing a safety sync
                // todo hook this up later cant deal with it now.
                // await this.storage.deleteOldDBPath()
                /* // LOCAL_OOS_TEST_SUPPORT  not for production
                  this.mainLogger.info('sync-p2p synced waiting 4 min')
                  await utils.sleep(240000) //do not release this helps us have a chance
                  //to query /config before the node syncs data
                */
                this.mainLogger.info('sync-syncAppData');
                await this.syncAppData();
            }
        });
        Self.emitter.on('restore', async (cycleNumber) => {
            console.log('restore mode triggered on cycle', cycleNumber);
            this.logger.playbackLogState('restore', '', `Restore mode triggered on cycle ${cycleNumber}`);
            nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: entered. seen on cycle:${cycleNumber} ${(0, network_1.shardusGetTime)()}`);
            await this.stateManager.waitForShardCalcs();
            nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: got shard calcs. ${(0, network_1.shardusGetTime)()}`);
            // Start restoring state data
            try {
                this.stateManager.renewState();
                await this.stateManager.accountSync.initialSyncMain(3);
                console.log('restore - initialSyncMain finished');
                nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: syncAppData finished. ${(0, network_1.shardusGetTime)()}`);
            }
            catch (err) {
                console.log();
                this.fatalLogger.fatal('restore-failed with Error: ' +
                    utils.formatErrorMessage(err));
                nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: fail and apop self. ${(0, network_1.shardusGetTime)()}`);
                (0, Apoptosis_1.apoptosizeSelf)(`restore-failed: ${err?.message}`, 'Node stopped due to network restore failure.');
                return;
            }
            // After restoring state data, set syncing flags to true and go active
            await this.stateManager.startCatchUpQueue();
            console.log('restore - startCatchUpQueue');
            nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: finished startCatchUpQueue. ${(0, network_1.shardusGetTime)()}`);
            await this.app.sync();
            console.log('syncAppData - sync');
            await (0, Join_1.queueFinishedSyncingRequest)();
            console.log('syncAppData - queueFinishedSyncingRequest');
            nestedCounters_1.nestedCountersInstance.countEvent('restore', `restore event: queue finished-syncing-request ${(0, network_1.shardusGetTime)()}`);
            this.stateManager.appFinishedSyncing = true;
            this.stateManager.startProcessingCycleSummaries();
        });
        Self.emitter.on('active', (nodeId) => {
            // this.io.emit('DATA', `NODE ACTIVE ${nodeId}`)
            this.logger.playbackLogState('active', nodeId, '');
            if (this.reporter) {
                this.reporter.reportActive(nodeId);
                this.reporter.startReporting();
            }
            if (this.statistics)
                this.statistics.startSnapshots();
            this.emit('active', nodeId);
        });
        Self.emitter.on('failed', () => {
            this.mainLogger.info('shutdown: on failed event');
            this.shutdown(true);
        });
        Self.emitter.on('error', (e) => {
            console.log(e.message + ' at ' + e.stack);
            if (logger_1.logFlags.debug)
                this.mainLogger.debug('shardus.start() ' + e.message + ' at ' + e.stack);
            // normally fatal error keys should not be variable ut this seems like an ok exception for now
            this.shardus_fatal(`onError_ex` + e.message + ' at ' + e.stack, 'shardus.start() ' + e.message + ' at ' + e.stack);
            throw new Error(e);
        });
        Self.emitter.on('removed', async () => {
            // Omar - Why are we trying to call the functions in modules directly before exiting.
            //        The modules have already registered shutdown functions with the exitHandler.
            //        We should let exitHandler handle the shutdown process.
            /*
            if (this.statistics) {
              this.statistics.stopSnapshots()
              this.statistics.initialize()
            }
            if (this.reporter) {
              this.reporter.stopReporting()
              await this.reporter.reportRemoved(Self.id)
            }
            if (this.app) {
              this.app.deleteLocalAccountData()
              this._attemptRemoveAppliedListener()
              this._unlinkStateManager()
              await this.stateManager.cleanup()
            }
      
            // Shutdown cleanly
            process.exit()
      */
            this.mainLogger.info(`exitCleanly: removed`);
            if (this.reporter) {
                this.reporter.stopReporting();
                await this.reporter.reportRemoved(Self.id);
            }
            this.exitHandler.exitCleanly(`removed`, `removed from network in normal conditions`); // exits with status 0 so that PM2 can restart the process
        });
        Self.emitter.on('app-removed', async () => {
            this.mainLogger.info(`exitCleanly: app removed`);
            if (this.reporter) {
                this.reporter.stopReporting();
                await this.reporter.reportRemoved(Self.id);
            }
            this.exitHandler.exitCleanly(`removed`, `removed from network requested by app`); // exits with status 0 so that
        });
        Self.emitter.on('invoke-exit', async (tag, callstack, message, restart) => {
            // Omar - Why are we trying to call the functions in modules directly before exiting.
            //        The modules have already registered shutdown functions with the exitHandler.
            //        We should let exitHandler handle the shutdown process.
            /*
          this.fatalLogger.fatal('Shardus: caught apoptosized event; cleaning up')
          if (this.statistics) {
            this.statistics.stopSnapshots()
            this.statistics.initialize()
          }
          if (this.reporter) {
            this.reporter.stopReporting()
            await this.reporter.reportRemoved(Self.id)
          }
          if (this.app) {
            this.app.deleteLocalAccountData()
            this._attemptRemoveAppliedListener()
            this._unlinkStateManager()
            await this.stateManager.cleanup()
          }
          this.fatalLogger.fatal(
            'Shardus: caught apoptosized event; finished clean up'
          )
    */
            const exitType = restart ? 'exitCleanly' : 'exitUncleanly';
            nestedCounters_1.nestedCountersInstance.countRareEvent('fatal', `invoke-exit: ${tag} ${exitType}`);
            this.mainLogger.error(`invoke-exit: ${tag} ${exitType}`);
            this.mainLogger.error(message);
            this.mainLogger.error(callstack);
            if (this.reporter) {
                this.reporter.stopReporting();
                await this.reporter.reportRemoved(Self.id);
            }
            if (restart)
                this.exitHandler.exitCleanly(`invoke-exit: ${tag}`, `invoke-exit: ${tag}. but exiting cleanly for a restart`);
            // exits with status 0 so that PM2 can restart the process
            else
                this.exitHandler.exitUncleanly(`invoke-exit: ${tag}`, `invoke-exit: ${tag} ${exitType}`); // exits with status 1 so that PM2 CANNOT restart the process
        });
        Self.emitter.on('node-activated', async ({ ...params }) => {
            if (Modes_1.networkMode === 'shutdown')
                return;
            try {
                const result = this.app.eventNotify?.({ type: 'node-activated', ...params });
                if (result instanceof Promise) {
                    await result;
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing node-activated event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        Self.emitter.on('node-deactivated', async ({ ...params }) => {
            if (Modes_1.networkMode === 'shutdown')
                return;
            try {
                const result = this.app.eventNotify?.({ type: 'node-deactivated', ...params });
                if (result instanceof Promise) {
                    await result;
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing node-deactivated event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        Self.emitter.on('node-refuted', async ({ ...params }) => {
            try {
                if (!this.stateManager.currentCycleShardData)
                    throw new Error('No current cycle data');
                if (params.publicKey == null)
                    throw new Error('No node publicKey provided for node-refuted event');
                const consensusNodes = this.getConsenusGroupForAccount(params.publicKey);
                for (let node of consensusNodes) {
                    if (node.id === Self.id) {
                        const result = this.app.eventNotify?.({ type: 'node-refuted', ...params });
                        if (result instanceof Promise) {
                            await result;
                        }
                    }
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing node-refuted event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        Self.emitter.on('node-left-early', async ({ ...params }) => {
            try {
                if (!this.stateManager.currentCycleShardData)
                    throw new Error('No current cycle data');
                if (params.publicKey == null)
                    throw new Error('No node publicKey provided for node-left-early event');
                const consensusNodes = this.getConsenusGroupForAccount(params.publicKey);
                for (let node of consensusNodes) {
                    if (node.id === Self.id) {
                        const result = this.app.eventNotify?.({ type: 'node-left-early', ...params });
                        if (result instanceof Promise) {
                            await result;
                        }
                    }
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing node-left-early event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        Self.emitter.on('node-sync-timeout', async ({ ...params }) => {
            try {
                if (!this.stateManager.currentCycleShardData)
                    throw new Error('No current cycle data');
                if (params.publicKey == null)
                    throw new Error('No node publicKey provided for node-sync-timeout event');
                const consensusNodes = this.getConsenusGroupForAccount(params.publicKey);
                for (let node of consensusNodes) {
                    if (node.id === Self.id) {
                        const result = this.app.eventNotify?.({ type: 'node-sync-timeout', ...params });
                        if (result instanceof Promise) {
                            await result;
                        }
                        break;
                    }
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing node-sync-timeout event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        Self.emitter.on('try-network-transaction', async ({ ...params }) => {
            try {
                const result = this.app.eventNotify?.({ type: 'try-network-transaction', ...params });
                if (result instanceof Promise) {
                    await result;
                }
            }
            catch (e) {
                this.mainLogger.error(`Error: while processing try-network-transaction event stack: ${utils.formatErrorMessage(e)}`);
            }
        });
        // Start P2P
        await Self.startupV2(this);
        // handle config queue changes and debug logic updates
        this._registerListener(this.p2p.state, 'cycle_q1_start', async () => {
            let lastCycle = CycleChain.getNewest();
            if (lastCycle === null) {
                return;
            }
            // need to make sure sync is finish or we may not have the global account
            // even worse, the dapp may not have initialized storage yet
            if (this.stateManager.appFinishedSyncing === true) {
                //query network account from the app for changes
                const account = await this.app.getNetworkAccount();
                this.updateConfigChangeQueue(account, lastCycle.counter, true);
            }
            this.updateDebug(lastCycle);
        });
        //setup debug endpoints
        this.setupDebugEndpoints();
    }
    /**
     * This function designed to help fetch the network account and
     * call updateConfigChangeQueue before our node has finished syncing
     * This is needed as a node will be sensitive to config changes
     * happening around the time it is syncing
     * @param {*} account
     * @param {*} lastCycle
     */
    async earlyConfigFetchAndPatch(lastCycle_counter) {
        if (this.config.p2p.patchNetworkAccountSyncFixes === false) {
            return;
        }
        try {
            //this funciton is for getting the network account early (i.e. from archivers)
            const account = await this.app.getNetworkAccountFromArchiver();
            if (account == null) {
                nestedCounters_1.nestedCountersInstance.countEvent('sync', 'earlyConfigFetchAndPatch is null');
                return;
            }
            else {
                nestedCounters_1.nestedCountersInstance.countEvent('sync', 'earlyConfigFetchAndPatch');
            }
            this.updateConfigChangeQueue(account, lastCycle_counter, false);
        }
        catch (e) {
            nestedCounters_1.nestedCountersInstance.countEvent('sync', 'earlyConfigFetchAndPatch failed: ' + e?.message);
        }
    }
    /**
     * Function used to register event listeners
     * @param {*} emitter Socket emitter to be called
     * @param {*} event Event name to be registered
     * @param {*} callback Callback function to be executed on event
     */
    _registerListener(emitter, event, callback) {
        if (this._listeners[event]) {
            this.shardus_fatal(`_registerListener_dupe`, 'Shardus can only register one listener per event! EVENT: ', event);
            return;
        }
        emitter.on(event, callback);
        this._listeners[event] = [emitter, callback];
    }
    /**
     * Function used to register event listeners
     * @param {*} event Name of the event to be unregistered
     */
    _unregisterListener(event) {
        if (!this._listeners[event]) {
            this.mainLogger.warn(`This event listener doesn't exist! Event: \`${event}\` in Shardus`);
            return;
        }
        const entry = this._listeners[event];
        const [emitter, callback] = entry;
        emitter.removeListener(event, callback);
        delete this._listeners[event];
    }
    /**
     * Function to unregister all event listeners
     */
    _cleanupListeners() {
        for (const event of Object.keys(this._listeners)) {
            this._unregisterListener(event);
        }
    }
    async _timestampAndQueueTransaction(tx, appData, global = false, noConsensus = false, loggingContext = '') {
        // Give the dapp an opportunity to do some up front work and generate
        // appData metadata for the applied TX
        const { status: preCrackSuccess, reason } = await this.app.txPreCrackData(tx, appData);
        if (this.config.stateManager.checkPrecrackStatus === true && preCrackSuccess === false) {
            return {
                success: false,
                reason: `PreCrack has failed. ${reason}`,
                status: 500,
            };
        }
        const injectedTimestamp = this.app.getTimestampFromTransaction(tx, appData);
        const txId = this.app.calculateTxId(tx);
        let timestampReceipt;
        let isMissingInjectedTimestamp = !injectedTimestamp || injectedTimestamp === -1;
        if (isMissingInjectedTimestamp) {
            if (injectedTimestamp === -1) {
                /* prettier-ignore */
                if (logger_1.logFlags.p2pNonFatal && logger_1.logFlags.console)
                    console.log("Dapp request to generate a new timestmap for the tx");
            }
            timestampReceipt = await this.stateManager.transactionConsensus.askTxnTimestampFromNode(txId);
            /* prettier-ignore */
            if (logger_1.logFlags.p2pNonFatal && logger_1.logFlags.console)
                console.log("Network generated a" +
                    " timestamp", txId, timestampReceipt);
        }
        if (isMissingInjectedTimestamp && !timestampReceipt) {
            this.shardus_fatal("put_noTimestamp", `Transaction timestamp cannot be determined ${utils.stringifyReduce(tx)} `);
            this.statistics.incrementCounter("txRejected");
            nestedCounters_1.nestedCountersInstance.countEvent("rejected", `_timestampNotDetermined-${loggingContext}`);
            return {
                success: false,
                reason: "Transaction timestamp cannot be determined.",
                status: 500
            };
        }
        let timestampedTx;
        if (timestampReceipt && timestampReceipt.timestamp) {
            timestampedTx = {
                tx,
                timestampReceipt
            };
        }
        else {
            timestampedTx = { tx };
        }
        // Perform fast validation of the transaction fields
        const validateResult = this.app.validate(timestampedTx, appData);
        if (validateResult.success === false) {
            // 400 is a code for bad tx or client faulty
            validateResult.status = validateResult.status ? validateResult.status : 400;
            return validateResult;
        }
        // Ask App to crack open tx and return timestamp, id (hash), and keys
        const { timestamp, id, keys, shardusMemoryPatterns } = this.app.crack(timestampedTx, appData);
        // console.log('app.crack results', timestamp, id, keys)
        // Validate the transaction's sourceKeys & targetKeys
        if (this.config.debug.checkAddressFormat && !(0, utils_1.isValidShardusAddress)(keys.allKeys)) {
            this.shardus_fatal(`put_invalidAddress`, `Invalid Shardus Address found: allKeys:${keys.allKeys} ${utils.stringifyReduce(tx)}`);
            this.statistics.incrementCounter("txRejected");
            nestedCounters_1.nestedCountersInstance.countEvent("rejected", "_hasInvalidShardusAddresses");
            return { success: false, reason: "Invalid Shardus Addresses", status: 400 };
        }
        // Validate the transaction timestamp
        let txExpireTimeMs = this.config.transactionExpireTime * 1000;
        if (global) {
            txExpireTimeMs = 2 * 10 * 1000; //todo consider if this should be a config.
        }
        if ((0, utils_1.inRangeOfCurrentTime)(timestamp, txExpireTimeMs, txExpireTimeMs) === false) {
            /* prettier-ignore */
            this.shardus_fatal(`tx_outofrange`, `Transaction timestamp out of range: timestamp:${timestamp} now:${(0, network_1.shardusGetTime)()} diff(now-ts):${(0, network_1.shardusGetTime)() - timestamp}  ${utils.stringifyReduce(tx)} our offset: ${(0, network_1.getNetworkTimeOffset)()} loggingContext: ${loggingContext}`);
            this.statistics.incrementCounter("txRejected");
            nestedCounters_1.nestedCountersInstance.countEvent("rejected", "transaction timestamp out of range");
            return { success: false, reason: "Transaction timestamp out of range", status: 400 };
        }
        this.profiler.profileSectionStart("put");
        //as ShardusMemoryPatternsInput
        // Pack into acceptedTx, and pass to StateManager
        const acceptedTX = {
            timestamp,
            txId: id,
            keys,
            data: timestampedTx,
            appData,
            shardusMemoryPatterns: shardusMemoryPatterns
        };
        if (logger_1.logFlags.verbose)
            this.mainLogger.debug("Transaction validated");
        if (global === false) {
            //temp way to make global modifying TXs not over count
            this.statistics.incrementCounter("txInjected");
        }
        this.logger.playbackLogNote("tx_injected", `${txId}`, `Transaction: ${utils.stringifyReduce(timestampedTx)}`);
        let added = this.stateManager.transactionQueue.routeAndQueueAcceptedTransaction(acceptedTX, 
        /*send gossip*/ true, null, global, noConsensus);
        if (logger_1.logFlags.verbose) {
            this.mainLogger.debug(`End of injectTransaction ${utils.stringifyReduce(tx)}, added: ${added}`);
        }
        return {
            success: true,
            reason: "Transaction queued, poll for results.",
            status: 200,
            txId
        };
    }
    /**
     * Function used to register listeners for transaction related events
     */
    _attemptCreateAppliedListener() {
        if (!this.statistics || !this.stateManager)
            return;
        this._registerListener(this.stateManager.eventEmitter, 'txQueued', (txId) => this.statistics.startTimer('txTimeInQueue', txId));
        this._registerListener(this.stateManager.eventEmitter, 'txPopped', (txId) => this.statistics.stopTimer('txTimeInQueue', txId));
        this._registerListener(this.stateManager.eventEmitter, 'txApplied', () => this.statistics.incrementCounter('txApplied'));
        this._registerListener(this.stateManager.eventEmitter, 'txProcessed', () => this.statistics.incrementCounter('txProcessed'));
        this._registerListener(this.stateManager.eventEmitter, 'txExpired', () => this.statistics.incrementCounter('txExpired'));
    }
    /**
     * Function to unregister all transaction related events
     */
    _attemptRemoveAppliedListener() {
        if (!this.statistics || !this.stateManager)
            return;
        this._unregisterListener('txQueued');
        this._unregisterListener('txPopped');
        this._unregisterListener('txApplied');
        this._unregisterListener('txProcessed');
    }
    /**
     * function to unregister listener for the "accepted" event
     */
    _unlinkStateManager() {
        this._unregisterListener('accepted');
    }
    /**
     * Creates an instance of the StateManager module and registers the "accepted" event listener for queueing transactions
     */
    _createAndLinkStateManager() {
        this.stateManager = new state_manager_1.default(this.profiler, this.app, this.logger, this.storage, this.p2p, this.crypto, this.config, this);
        this.storage.stateManager = this.stateManager;
        Context.setStateManagerContext(this.stateManager);
    }
    /**
     * Function used to allow shardus to sync data specific to an app if it should be required
     */
    async syncAppData() {
        if (!this.app) {
            //await this.p2p.
            let readyPayload = {
                nodeId: Self.id,
                cycleNumber: CycleChain.getNewest()?.counter,
            };
            readyPayload = Context.crypto.sign(readyPayload);
            Comms.sendGossip('gossip-sync-finished', readyPayload, undefined, undefined, (0, Join_1.nodeListFromStates)([
                lib_types_2.P2P.P2PTypes.NodeStatus.ACTIVE,
                lib_types_2.P2P.P2PTypes.NodeStatus.READY,
                lib_types_2.P2P.P2PTypes.NodeStatus.SYNCING,
            ]));
            if (this.stateManager) {
                this.stateManager.appFinishedSyncing = true;
            }
            return;
        }
        console.log('syncAppData');
        if (this.stateManager) {
            try {
                await this.stateManager.accountSync.initialSyncMain(3);
                console.log('syncAppData - initialSyncMain finished');
            }
            catch (err) {
                this.fatalLogger.fatal('initialSyncMain-failed with Error: ' +
                    utils.formatErrorMessage(err));
                nestedCounters_1.nestedCountersInstance.countEvent('syncAppData', `initialSyncMain event: fail and apop self. ${(0, network_1.shardusGetTime)()}`);
                (0, Apoptosis_1.apoptosizeSelf)(`initialSyncMain-failed: ${err?.message}`, 'Node stopped due to node performance or network issues during initial app data sync.');
                return;
            }
        }
        // if (this.stateManager) await this.stateManager.accountSync.syncStateDataFast(3) // fast mode
        if (this.p2p.isFirstSeed) {
            console.log('syncAppData - isFirstSeed');
            // the following comment of delay is probably not relavent now as we are using cycle txs
            // we don't have a delay here as there's practically no time between sync-started and sync-finished for the first node
            // since we already wait fro sync-finished, its very unlikely we'll be in the wrong quarter
            await (0, Join_1.queueFinishedSyncingRequest)();
            console.log('syncAppData - queueFinishedSyncingRequest');
            nestedCounters_1.nestedCountersInstance.countEvent('p2p', `queue finished-syncing-request ${(0, network_1.shardusGetTime)()}`);
            await this.stateManager.waitForShardCalcs();
            await this.app.sync();
            console.log('syncAppData - sync');
            this.stateManager.appFinishedSyncing = true;
            Self.setp2pIgnoreJoinRequests(false);
            console.log('p2pIgnoreJoinRequests = false');
        }
        else {
            await this.stateManager.startCatchUpQueue();
            console.log('syncAppData - startCatchUpQueue');
            await this.app.sync();
            console.log('syncAppData - sync');
            Self.setp2pIgnoreJoinRequests(false);
            console.log('p2pIgnoreJoinRequests = false');
            await (0, Join_1.queueFinishedSyncingRequest)();
            console.log('syncAppData - queueFinishedSyncingRequest');
            nestedCounters_1.nestedCountersInstance.countEvent('p2p', `queue finished-syncing-request ${(0, network_1.shardusGetTime)()}`);
            this.stateManager.appFinishedSyncing = true;
        }
        // Set network joinable to true
        this.p2p.setJoinRequestToggle(true);
        console.log('Server ready!');
        if (this.stateManager) {
            await utils.sleep(3000);
            // Original sync check
            // this.stateManager.enableSyncCheck()
            // Partition check and data repair (new)
            // disable and compare this.stateManager.startSyncPartitions()
            //this.stateManager.partitionObjects.startSyncPartitions()
            this.stateManager.startProcessingCycleSummaries();
        }
    }
    /**
     * Calls the "put" function with the "set" boolean parameter set to true
     * @param {*} tx The transaction data
     */
    set(tx) {
        return this.put(tx, true, false);
    }
    /**
     * Allows the application to log specific data to an app.log file
     * @param  {...any} data The data to be logged in app.log file
     */
    log(...data) {
        if (logger_1.logFlags.debug) {
            this.appLogger.debug(new Date(), ...data);
        }
    }
    /**
     * Gets log flags.
     * use these for to cull out slow log lines with stringify
     * if you pass comma separated objects to dapp.log you do not need this.
     * Also good for controlling console logging
     */
    getLogFlags() {
        return logger_1.logFlags;
    }
    /**
     * Submits a transaction to the network
     * Returns an object that tells whether a tx was successful or not and the reason why via the
     * validateTxnFields application SDK function.
     * Throws an error if an application was not provided to shardus.
     *
     * @param tx the TX format is not known to shardus core and can be any object
     * @param set this is an old feaure that can be used by the first node in the network to inject TXs early. candidate for deprecation
     * @param global this is used for injecting a tx that changes a global account completely different consensus is used for these.  see src/p2p/GlobalAccounts.ts
     * @param inputAppData optional opaque app data that can be passed in.  this is forwared to the dapp when precrack is called.
     * @returns
     * {
     *   success: boolean,
     *   reason: string,
     *   staus: number
     * }
     */
    async put(tx, set = false, global = false, inputAppData = null) {
        const noConsensus = set || global;
        const txId = this.app.calculateTxId(tx);
        /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
            this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: inject:${(0, network_1.shardusGetTime)()}`);
        // Check if Consensor is ready to receive txs before processing it further
        if (!this.appProvided)
            throw new Error('Please provide an App object to Shardus.setup before calling Shardus.put');
        if (logger_1.logFlags.verbose)
            this.mainLogger.debug(`Start of injectTransaction ${lib_types_1.Utils.safeStringify(tx)} set:${set} global:${global}`); // not reducing tx here so we can get the long hashes
        if (!this.stateManager.accountSync.dataSyncMainPhaseComplete) {
            this.statistics.incrementCounter('txRejected');
            nestedCounters_1.nestedCountersInstance.countEvent('rejected', '!dataSyncMainPhaseComplete');
            return { success: false, reason: 'Node is still syncing.', status: 500 };
        }
        if (!this.stateManager.hasCycleShardData()) {
            this.statistics.incrementCounter('txRejected');
            nestedCounters_1.nestedCountersInstance.countEvent('rejected', '!hasCycleShardData');
            return {
                success: false,
                reason: 'Not ready to accept transactions, shard calculations pending',
                status: 500,
            };
        }
        // set === true (which is handled in the else case here) is a special kind of TX that is allowed only be the first node in the network
        // this is used to create global network settings and other dawn of time accounts
        if (set === false) {
            if (!this.p2p.allowTransactions()) {
                if (global === true && this.p2p.allowSet()) {
                    // This ok because we are initializing a global at the set time period
                }
                else {
                    if (logger_1.logFlags.verbose)
                        this.mainLogger.debug(`txRejected ${lib_types_1.Utils.safeStringify(tx)} set:${set} global:${global}`);
                    this.statistics.incrementCounter('txRejected');
                    nestedCounters_1.nestedCountersInstance.countEvent('rejected', '!allowTransactions');
                    return {
                        success: false,
                        reason: 'Network conditions to allow transactions are not met.',
                        status: 500,
                    };
                }
            }
        }
        else {
            // this is where set is true.  check if we allow it (i.e. only one node active). if not, reject early
            if (!this.p2p.allowSet()) {
                this.statistics.incrementCounter('txRejected');
                nestedCounters_1.nestedCountersInstance.countEvent('rejected', '!allowTransactions2');
                return {
                    success: false,
                    reason: 'Network conditions to allow app init via set',
                    status: 500,
                };
            }
        }
        // Now it is time to check rate limiting to see if our node can accept more transactions
        if (this.rateLimiting.isOverloaded(txId)) {
            /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: reject_overload`);
            this.statistics.incrementCounter('txRejected');
            nestedCounters_1.nestedCountersInstance.countEvent('rejected', 'isOverloaded');
            return { success: false, reason: 'Maximum load exceeded.', status: 500 };
        }
        try {
            // Perform basic validation of the transaction fields
            if (logger_1.logFlags.verbose)
                this.mainLogger.debug('Performing initial validation of the transaction');
            // inputAppData is a new concept that allows the JSON RPC Server to pass in a TX as well as additional
            // metadata for the dapp.  This data is then passed into precrack to be used for whatever calculations are needed
            let appData = inputAppData ?? {};
            const internalTx = this.app.isInternalTx(tx);
            if (internalTx && !(0, Modes_1.isInternalTxAllowed)()) {
                return {
                    success: false,
                    reason: `Internal transactions are not allowed in ${Modes_1.networkMode} Mode.`,
                    status: 500,
                };
            }
            if (!internalTx && Modes_1.networkMode !== 'processing') {
                return {
                    success: false,
                    reason: `Application transactions are only allowed in processing Mode.`,
                    status: 500,
                };
            }
            const senderAddress = this.app.getTxSenderAddress(tx);
            /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: sender:${senderAddress}`);
            // Forward transaction to a node that has the account data locally if we don't have it
            if (global === false) {
                if (senderAddress == null) {
                    return {
                        success: false,
                        reason: `Sender address is not available.`,
                        status: 500
                    };
                }
                const consensusGroup = this.getConsenusGroupForAccount(senderAddress);
                const isConsensusNode = consensusGroup.some((node) => node.id === Self.id);
                if (Context.config.stateManager.forwardToLuckyNodes) {
                    if (isConsensusNode === false) {
                        // send transaction to lucky consensus group node
                        const result = await this.forwardTransactionToLuckyNodes(senderAddress, tx, 'non-consensus to consensus', '1');
                        return result;
                    }
                    // careful we may be consensus node but if we are not lucky we should forward to lucky nodes
                    let luckyNodeIds = this.getClosestNodes(senderAddress, Context.config.stateManager.numberOfReInjectNodes, false);
                    let isLuckyNode = luckyNodeIds.some((nodeId) => nodeId === Self.id);
                    if (isLuckyNode === false) {
                        const result = await this.forwardTransactionToLuckyNodes(senderAddress, tx, 'non-lucky consensus to lucky' +
                            ' consensus', '2');
                        return result;
                    }
                }
            }
            // we are consensus lucky node for this tx
            let shouldAddToNonceQueue = false;
            let txNonce;
            if (internalTx === false) {
                let senderAccountNonce = await this.app.getAccountNonce(senderAddress);
                txNonce = await this.app.getNonceFromTx(tx);
                /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                    this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: sNonce:${senderAccountNonce}`);
                /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                    this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: txNonce:${txNonce}`);
                if (senderAccountNonce == null) {
                    if (this.config.mode === ShardusTypes.ServerMode.Release) {
                        return {
                            success: false,
                            reason: `Sender account nonce is not available. ${utils.stringifyReduce(tx)}`,
                            status: 500
                        };
                    }
                    senderAccountNonce = BigInt(0);
                }
                // app layer should return -1 if the account or tx does not have a nonce field
                if (txNonce >= 0 && senderAccountNonce >= 0) {
                    if (txNonce < senderAccountNonce) {
                        if (logger_1.logFlags.debug)
                            this.mainLogger.debug(`txNonce < senderAccountNonce ${txNonce} < ${senderAccountNonce}`);
                        nestedCounters_1.nestedCountersInstance.countEvent('rejected', 'txNonce < senderAccountNonce');
                        return {
                            success: false,
                            reason: `Transaction nonce is less than the account nonce. ${txNonce} < ${senderAccountNonce} ${utils.stringifyReduce(tx)}  `,
                            status: 500
                        };
                    }
                    else if (txNonce > senderAccountNonce) {
                        // if the tx is already in the nonceQueue (based on txid not nonce), return an accepted response
                        const txInNonceQueue = this.stateManager.transactionQueue.isTxInPendingNonceQueue(senderAddress, txId);
                        if (txInNonceQueue) {
                            return {
                                success: true,
                                reason: `Transaction is already in pending nonce queue.`,
                                status: 200
                            };
                        }
                        if (logger_1.logFlags.debug)
                            this.mainLogger.debug(`txNonce > senderAccountNonce ${txNonce} > ${senderAccountNonce} but txId is not in nonce queue yet`);
                        // decide whether to put it in the nonce queue or not
                        const maxAllowedPendingNonce = senderAccountNonce + BigInt(Context.config.stateManager.maxPendingNonceTxs);
                        if (txNonce <= maxAllowedPendingNonce) {
                            shouldAddToNonceQueue = true;
                            if (logger_1.logFlags.debug)
                                this.mainLogger.debug(`txNonce > senderAccountNonce ${txNonce} > ${senderAccountNonce}`);
                        }
                        else {
                            if (logger_1.logFlags.debug)
                                this.mainLogger.debug(`txNonce > senderAccountNonce ${txNonce} > ${senderAccountNonce} + ${Context.config.stateManager.maxPendingNonceTxs}`);
                            nestedCounters_1.nestedCountersInstance.countEvent('rejected', 'txNonce > senderAccountNonce + maxPendingNonceTxs');
                            return {
                                success: false,
                                reason: `Transaction nonce ${txNonce.toString()} is greater than max allowed pending nonce of ${maxAllowedPendingNonce.toString()}`,
                                status: 500
                            };
                        }
                    }
                }
            }
            const shouldQueueNonceButPoolIsFull = shouldAddToNonceQueue &&
                this.config.stateManager.maxNonceQueueSize <= this.stateManager.transactionQueue.nonceQueue.size;
            //ITN fix. There will be separate effort to protect the pool more intelligently for mainnet.
            if (shouldQueueNonceButPoolIsFull) {
                /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                    this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: reject_nonce_full`);
                nestedCounters_1.nestedCountersInstance.countEvent('rejected', `Nonce pool is full, try again later`);
                return {
                    success: false,
                    reason: `Nonce pool is full, try again later`,
                    status: 500,
                };
            }
            if (shouldAddToNonceQueue) {
                const nonceQueueEntry = {
                    tx,
                    txId,
                    accountId: senderAddress,
                    nonce: txNonce,
                    appData,
                    global,
                    noConsensus,
                };
                let nonceQueueAddResult = this.stateManager.transactionQueue.addTransactionToNonceQueue(nonceQueueEntry);
                if (Context.config.stateManager.forwardToLuckyNodesNonceQueue) {
                    // if we ever support cancellation by using replacment for a TX that will change how we
                    // need to handle this run-away protection.  may need to re-evaluate later
                    if (nonceQueueAddResult?.alreadyAdded === true && Context.config.stateManager.forwardToLuckyNodesNonceQueueLimitFix) {
                        nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forwardTxToConsensusGroup: nonce queue skipped. we already have it`);
                        return {
                            success: true,
                            reason: `Transaction already added to pending nonce queue.`,
                            status: 200
                        };
                    }
                    let result = this.forwardTransactionToLuckyNodes(senderAddress, tx, txId, 'consensus to consensus', '3'); // don't wait here
                    return result;
                }
                else {
                    return {
                        success: true,
                        reason: `Transaction added to pending nonce queue.`,
                        status: 200
                    };
                }
            }
            else {
                // tx nonce is equal to account nonce
                let result = await this._timestampAndQueueTransaction(tx, appData, global, noConsensus, 'immediateQueue');
                // start of timestamp logging
                if (logger_1.logFlags.important_as_error) {
                    const txTimestamp = this.app.getTimestampFromTransaction(tx, appData);
                    const nowNodeTimestamp = (0, network_1.shardusGetTime)();
                    const ntpOffset = (0, network_1.getNetworkTimeOffset)();
                    /* prettier-ignore */ console.log(`TxnTS: shardus.put() txTimestamp=${txTimestamp}, nowNodeTimestamp=${nowNodeTimestamp}, ntpOffset=${ntpOffset}, txID=${txId}`);
                }
                // end of timestamp logging.
                return result;
            }
            // Pass received txs to any subscribed 'DATA' receivers
            // this.io.emit('DATA', tx)
        }
        catch (err) {
            this.shardus_fatal(`put_ex_` + err.message, `Put: Failed to process transaction. Exception: ${err}`);
            this.fatalLogger.fatal('Put: ' + err.name + ': ' + err.message + ' at ' + err.stack);
            return {
                success: false,
                reason: `Failed to process transaction: ${utils.stringifyReduce(tx)} ${(0, util_1.inspect)(err)}`,
                status: 500, // 500 status code means transaction is generally failed
            };
        }
        finally {
            this.profiler.profileSectionEnd('put');
        }
    }
    async forwardTransactionToLuckyNodes(senderAddress, tx, txId, message = '', context = '') {
        let closetNodeIds = this.getClosestNodes(senderAddress, Context.config.stateManager.numberOfReInjectNodes, false);
        const cycleShardData = this.stateManager.currentCycleShardData;
        const homeNode = shardFunctions_1.default.findHomeNode(cycleShardData.shardGlobals, senderAddress, cycleShardData.parititionShardDataMap);
        if (homeNode == null) {
            return { success: false, reason: `Home node not found for account ${senderAddress}`, status: 500 };
        }
        /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
            this.mainLogger.debug(`forwardTransactionToLuckyNodes: homeNode: ${homeNode.node.id} closetNodeIds: ${lib_types_1.Utils.safeStringify(closetNodeIds.sort())}`);
        let selectedValidators = [];
        if (Self.id != homeNode.node.id)
            selectedValidators.push({
                id: homeNode.node.id,
                ip: homeNode.node.externalIp,
                port: homeNode.node.externalPort,
                publicKey: homeNode.node.publicKey,
            });
        /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
            this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_homenode_${context} ${NodeList_1.activeIdToPartition.get(homeNode.node.id)}`);
        let stats = {
            skippedSelf: 0,
            skippedRotation: 0,
            skippedHome: 0,
            ok_inQ: 0,
            ok_inQ2: 0,
            ok_addQ: 0
        };
        for (const id of closetNodeIds) {
            /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_closetnode_${context} ${NodeList_1.activeIdToPartition.get(id)}`);
            if (id === Self.id) {
                stats.skippedSelf++;
                continue;
            }
            if (id === homeNode.node.id) {
                stats.skippedHome++;
                continue; // we already added the home node
            }
            let node = NodeList_1.nodes.get(id);
            //is this node safe in terms of rotation
            let rotationCheckPassed = true;
            if (Context.config.stateManager.forwardToLuckyNodesCheckRotation) {
                //is in rotation means it in the edge
                rotationCheckPassed = (0, Utils_1.isNodeInRotationBounds)(id) === false;
            }
            // if the node is not active or not in rotation bounds, skip it
            if (node.status !== 'active' || (rotationCheckPassed === false)) {
                /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                    this.mainLogger.debug(`forwardTransactionToLuckyNodes: node ${id} is not active or in rotation bounds. node.status: ${node.status} isNodeInRotationBounds: ${(0, Utils_1.isNodeInRotationBounds)(id)}`);
                stats.skippedRotation++;
                continue;
            }
            const validatorDetails = {
                id: node.id,
                ip: node.externalIp,
                port: node.externalPort,
                publicKey: node.publicKey,
            };
            selectedValidators.push(validatorDetails);
        }
        let successCount = 0;
        let failedCount = 0;
        for (const validator of selectedValidators) {
            try {
                /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                    this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_req_${context} ${NodeList_1.activeIdToPartition.get(validator.id)}`);
                if (validator.id === homeNode.node.id) {
                    /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                        this.mainLogger.debug(`Forwarding injected tx ${txId} to home node ${validator.id} reason: ${message} ${lib_types_1.Utils.safeStringify(tx)}`);
                    nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forwardTxToHomeNode: ${message}`);
                }
                else {
                    /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                        this.mainLogger.debug(`Forwarding injected tx ${txId} to consensus group. reason: ${message} ${lib_types_1.Utils.safeStringify(tx)}`);
                    nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forwardTxToConsensusGroup: ${message}`);
                }
                const result = await this.app.injectTxToConsensor([validator], tx);
                if (result == null) {
                    /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                        this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_null_${context} ${NodeList_1.activeIdToPartition.get(validator.id)}`);
                    /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                        this.mainLogger.debug(`Got null/undefined response upon forwarding injected tx: ${txId} to node ${validator.id}`);
                    failedCount++;
                    continue;
                }
                if (result && result.success === false) {
                    /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                        this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_false_${context} ${NodeList_1.activeIdToPartition.get(validator.id)}`);
                    /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                        this.mainLogger.debug(`Got unsuccessful response upon forwarding injected tx: ${validator.id}. ${message} ${lib_types_1.Utils.safeStringify(tx)}`);
                    failedCount++;
                    continue;
                }
                if (result && result.success === true) {
                    /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                        this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_success_${context} ${NodeList_1.activeIdToPartition.get(validator.id)}`);
                    /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                        this.mainLogger.debug(`Got successful response upon forwarding injected tx: ${validator.id}. ${message} ${lib_types_1.Utils.safeStringify(tx)}`);
                    if (result.reason === 'Transaction is already in pending nonce queue.') {
                        stats.ok_inQ++;
                    }
                    if (result.reason === `Transaction already added to pending nonce queue.`) {
                        stats.ok_inQ2++;
                    }
                    if (result.reason === `Transaction added to pending nonce queue.`) {
                        stats.ok_addQ++;
                    }
                    nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forward to lucky node success ${message} ${lib_types_1.Utils.safeStringify(stats)}`);
                    if (Context.config.stateManager.forwardToLuckyMulti) {
                        successCount++;
                        continue;
                    }
                    return { success: true, reason: 'Transaction forwarded to validators', status: 200 };
                }
            }
            catch (e) {
                /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                    this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_ex_${context} ${NodeList_1.activeIdToPartition.get(validator.id)}`);
                /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                    this.mainLogger.error(`Forwarding injected tx to ${validator.id} failed. ${message} ${lib_types_1.Utils.safeStringify(tx)} error: ${e.stack}`);
            }
        }
        if (successCount > 0) {
            /* prettier-ignore */ if (logger_1.logFlags.seqdiagram)
                this.seqLogger.info(`0x53455106 ${(0, network_1.shardusGetTime)()} tx:${txId} Note over ${NodeList_1.activeIdToPartition.get(Self.id)}: lucky_forward_success_${context}`);
            /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
                this.mainLogger.debug(`Got successful response upon forwarding injected tx: ${message} ${lib_types_1.Utils.safeStringify(tx)}`);
            nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forward to luck success ${message} failed/success/total: ${failedCount}/${successCount}/${selectedValidators.length}`);
            return { success: true, reason: 'Transaction forwarded to validators', status: 200 };
        }
        nestedCounters_1.nestedCountersInstance.countEvent('statistics', `forward failed: ${message} ${lib_types_1.Utils.safeStringify(stats)}`);
        /* prettier-ignore */ if (logger_1.logFlags.debug || logger_1.logFlags.rotation)
            this.mainLogger.error(`Forwarding injected tx out of tries. ${lib_types_1.Utils.safeStringify(stats)} ${lib_types_1.Utils.safeStringify(tx)} `);
        return { success: false, reason: 'No validators found to forward the transaction', status: 500 };
    }
    /**
     * Returns the nodeId for this node
     */
    getNodeId() {
        return this.p2p.getNodeId();
    }
    /**
     * Returns node info given a node id
     * @param {*} id The nodeId of this node
     */
    getNode(id) {
        return this.p2p.state.getNode(id);
    }
    getRemovedNodePubKeyFromCache(id) {
        return this.p2p.state.getRemovedNodePubKeyFromCache(id);
    }
    getNodeByPubKey(id) {
        return this.p2p.state.getNodeByPubKey(id);
    }
    getNodeRotationIndex(id) {
        return (0, NodeList_1.getAgeIndexForNodeId)(id);
    }
    isNodeInRotationBounds(nodeId) {
        return (0, Utils_1.isNodeInRotationBounds)(nodeId);
    }
    isNodeActiveByPubKey(pubKey) {
        const node = this.p2p.state.getNodeByPubKey(pubKey);
        if (node == null) {
            return false;
        }
        if (node.status !== P2PTypes_1.NodeStatus.ACTIVE) {
            return false;
        }
        return true;
    }
    isNodeReadyByPubKey(pubKey) {
        const node = this.p2p.state.getNodeByPubKey(pubKey);
        if (node == null) {
            return false;
        }
        if (node.status !== P2PTypes_1.NodeStatus.READY) {
            return false;
        }
        return true;
    }
    isNodeSyncingByPubKey(pubKey) {
        const node = this.p2p.state.getNodeByPubKey(pubKey);
        if (node == null) {
            return false;
        }
        if (node.status !== P2PTypes_1.NodeStatus.SYNCING) {
            return false;
        }
        return true;
    }
    isNodeSelectedByPubKey(pubKey) {
        const node = this.p2p.state.getNodeByPubKey(pubKey);
        if (node == null) {
            return false;
        }
        if (node.status !== P2PTypes_1.NodeStatus.SELECTED) {
            return false;
        }
        return true;
    }
    isNodeActive(id) {
        const node = this.p2p.state.getNode(id);
        if (node == null) {
            return false;
        }
        if (node.status !== P2PTypes_1.NodeStatus.ACTIVE) {
            return false;
        }
        return true;
    }
    /**
     * Returns an array of cycles in the cycleChain history starting from the current cycle
     * @param {*} amount The number cycles to fetch from the recent cycle history
     */
    getLatestCycles(amount = 1) {
        return this.p2p.getLatestCycles(amount);
    }
    /**
     * This function return number of active in the latest cycle.
     */
    getNumActiveNodes() {
        let lastCycle = CycleChain.getNewest();
        if (lastCycle == null) {
            nestedCounters_1.nestedCountersInstance.countEvent('debug', 'getNumActiveNodes lastCycle == null');
            return 0;
        }
        nestedCounters_1.nestedCountersInstance.countEvent('debug', `getNumActiveNodes lastCycle.active: ${lastCycle.active}`);
        const latestCycle = this.p2p.getLatestCycles(1)[0];
        if (latestCycle == null) {
            nestedCounters_1.nestedCountersInstance.countEvent('debug', 'getNumActiveNodes latestCycle == null');
            return 0;
        }
        nestedCounters_1.nestedCountersInstance.countEvent('debug', `getNumActiveNodes latestCycle.active: ${latestCycle.active}`);
        return latestCycle ? latestCycle.active : 0;
    }
    fastIsPicked(numberToPick) {
        let numActiveNodes = NodeList.activeByIdOrder.length;
        if (numActiveNodes < Context_1.config.p2p.scaleGroupLimit) {
            return true;
        }
        let offset = CycleChain.newest.counter; //todo something more random
        const ourIndex = (0, Utils_1.getOurNodeIndex)();
        if (ourIndex == null)
            return false;
        return (0, utils_1.fastIsPicked)(ourIndex, numActiveNodes, numberToPick, offset);
    }
    /**
     *
     * @returns {ShardusTypes.Cycle['mode']} returns the current network mode
     */
    getNetworkMode() {
        return Modes_1.networkMode;
    }
    /**
     * @typedef {import('../shardus/index.js').Node} Node
     */
    /**
     * getClosestNodes finds the closes nodes to a certain hash value
     * @param {string} hash any hash address (256bit 64 characters)
     * @param {number} count how many nodes to return
     * @param {boolean} selfExclude
     * @returns {string[]} returns a list of nodes ids that are closest. roughly in order of closeness
     */
    getClosestNodes(hash, count = 1, selfExclude = false) {
        return this.stateManager.getClosestNodes(hash, count, selfExclude).map((node) => node.id);
    }
    checkCycleShardData(tag) {
        return this.stateManager.checkCycleShardData(tag);
    }
    getClosestNodesGlobal(hash, count) {
        return this.stateManager.getClosestNodesGlobal(hash, count);
    }
    removeNodeWithCertificiate(cert) {
        return (0, Lost_1.removeNodeWithCertificiate)(cert);
    }
    computeNodeRank(nodeId, txId, timestamp) {
        return this.stateManager.transactionQueue.computeNodeRank(nodeId, txId, timestamp);
    }
    getShardusProfiler() {
        return profiler_1.profilerInstance;
    }
    /** Get the time in MS a replacement for Date.Now().  If p2p.useNTPOffsets===true then adds the NPT offset  */
    shardusGetTime() {
        return (0, network_1.shardusGetTime)();
    }
    setDebugSetLastAppAwait(label, complete = TransactionQueue_1.DebugComplete.Incomplete) {
        this.stateManager?.transactionQueue.setDebugSetLastAppAwait(label, complete);
    }
    validateClosestActiveNodeSignatures(signedAppData, signs, minRequired, nodesToSign, allowedBackupNodes) {
        // let validNodes = []
        let appData = { ...signedAppData };
        if (appData.signs)
            delete appData.signs;
        if (appData.sign)
            delete appData.sign;
        const hash = crypto.hashObj(appData);
        const closestNodes = this.getClosestNodes(hash, nodesToSign + allowedBackupNodes);
        const closestNodesByPubKey = new Map();
        for (let i = 0; i < closestNodes.length; i++) {
            const node = this.p2p.state.getNode(closestNodes[i]);
            if (node) {
                closestNodesByPubKey.set(node.publicKey, node);
            }
        }
        const validSigns = new Set();
        for (let i = 0; i < signs.length; i++) {
            const sign = signs[i];
            const nodePublicKey = sign.owner;
            appData.sign = sign; // attach the node's sig for verification
            if (!closestNodesByPubKey.has(nodePublicKey)) {
                this.mainLogger.warn(`Node ${nodePublicKey} is not in the closest nodes list. Skipping`);
                continue;
            }
            const node = closestNodesByPubKey.get(nodePublicKey);
            const isValid = this.crypto.verify(appData, nodePublicKey);
            if (node && isValid) {
                validSigns.add(sign.sig);
            }
            // early break loop
            if (validSigns.size >= minRequired) {
                // if (validNodes.length >= minRequired) {
                return {
                    success: true,
                    reason: `Validated by ${minRequired} valid nodes!`,
                };
            }
        }
        return {
            success: false,
            reason: `Fail to verify enough valid nodes signatures`,
        };
    }
    /**
     * isNodeInDistance
     * @param {string} hash any hash address (256bit 64 characters)
     * @param {string} nodeId id of a node
     * @param {number} distance how far away can this node be to the home node of the hash
     * @returns {boolean} is the node in the distance to the target
     */
    isNodeInDistance(hash, nodeId, distance) {
        //@ts-ignore
        return this.stateManager.isNodeInDistance(hash, nodeId, distance);
    }
    // USED BY SIMPLECOINAPP
    createApplyResponse(txId, txTimestamp) {
        const replyObject = {
            stateTableResults: [],
            txId,
            txTimestamp,
            accountData: [],
            accountWrites: [],
            appDefinedData: {},
            failed: false,
            failMessage: null,
            appReceiptData: null,
            appReceiptDataHash: null,
        };
        return replyObject;
    }
    async shutdownFromDapp(tag, message, restart) {
        const exitType = restart ? 'exitCleanly' : 'exitUncleanly';
        nestedCounters_1.nestedCountersInstance.countRareEvent('fatal', `invoke-exit: ${exitType}: ${tag}`);
        this.mainLogger.error(`invoke-exit: ${exitType}: ${tag}`);
        this.mainLogger.error(message);
        this.mainLogger.error((0, getCallstack_1.default)());
        if (this.reporter) {
            this.reporter.stopReporting();
            await this.reporter.reportRemoved(Self.id);
        }
        if (restart)
            // exits with status 0 so that PM2 can restart the process
            this.exitHandler.exitCleanly(`invoke-exit: ${tag}`, `invoke-exit: ${tag}. but exiting cleanly for a restart`);
        // exits with status 1 so that PM2 CANNOT restart the process
        else
            this.exitHandler.exitUncleanly(`invoke-exit: ${tag}`, `invoke-exit: ${exitType}: ${tag}`);
    }
    applyResponseAddReceiptData(resultObject, appReceiptData, appReceiptDataHash) {
        resultObject.appReceiptData = appReceiptData;
        resultObject.appReceiptDataHash = appReceiptDataHash;
    }
    applyResponseSetFailed(resultObject, failMessage) {
        resultObject.failed = true;
        resultObject.failMessage = failMessage;
    }
    // USED BY SIMPLECOINAPP
    applyResponseAddState(resultObject, //TODO define type! :{stateTableResults: ShardusTypes.StateTableObject[], accountData:ShardusTypes.WrappedResponse[] },
    accountData, localCache, accountId, txId, txTimestamp, stateBefore, stateAfter, accountCreated) {
        const state = { accountId, txId, txTimestamp, stateBefore, stateAfter };
        if (accountCreated) {
            state.stateBefore = allZeroes64;
        }
        //@ts-ignore
        resultObject.stateTableResults.push(state);
        let foundAccountData = resultObject.accountData.find((a) => a.accountId === accountId);
        if (foundAccountData) {
            foundAccountData = {
                ...foundAccountData,
                accountId,
                data: accountData,
                //@ts-ignore
                txId,
                timestamp: txTimestamp,
                hash: stateAfter,
                stateId: stateAfter,
                localCache,
            };
        }
        else {
            resultObject.accountData.push({
                accountId,
                data: accountData,
                //@ts-ignore
                txId,
                timestamp: txTimestamp,
                hash: stateAfter,
                stateId: stateAfter,
                localCache,
            });
        }
    }
    // USED BY SIMPLECOINAPP
    applyResponseAddChangedAccount(resultObject, //TODO define this type!
    accountId, account, txId, txTimestamp) {
        resultObject.accountWrites.push({
            accountId,
            data: account,
            txId,
            timestamp: txTimestamp,
        });
    }
    useAccountWrites() {
        console.log('Using accountWrites only');
        this.stateManager.useAccountWritesOnly = true;
    }
    tryInvolveAccount(txId, address, isRead) {
        try {
            const result = this.stateManager.transactionQueue.tryInvloveAccount(txId, address, isRead);
            return result;
        }
        catch (err) {
            this.fatalLogger.fatal('Error while checking tryInvolveAccount ' + err.name + ': ' + err.message + ' at ' + err.stack);
            return false;
        }
    }
    signAsNode(obj) {
        return this.crypto.sign(obj);
    }
    // USED BY SIMPLECOINAPP
    async resetAppRelatedState() {
        await this.storage.clearAppRelatedState();
    }
    // USED BY SIMPLECOINAPP
    async getLocalOrRemoteAccount(address, opts = { useRICache: false, canThrowException: false }) {
        if (this.p2p.allowTransactions() || (0, debug_2.isServiceMode)()) {
            return this.stateManager.getLocalOrRemoteAccount(address, opts);
        }
        else {
            return null;
        }
    }
    async getLocalOrRemoteCachedAppData(topic, dataId) {
        if (this.p2p.allowTransactions()) {
            return this.stateManager.cachedAppDataManager.getLocalOrRemoteCachedAppData(topic, dataId);
        }
        else {
            return null;
        }
    }
    async getLocalOrRemoteAccountQueueCount(address) {
        if (this.p2p.allowTransactions()) {
            return this.stateManager.getLocalOrRemoteAccountQueueCount(address);
        }
        else {
            return { count: 0, committingAppData: [] };
        }
    }
    async registerCacheTopic(topic, maxCycleAge, maxCacheElements) {
        try {
            return this.stateManager.cachedAppDataManager.registerTopic(topic, maxCycleAge, maxCacheElements);
        }
        catch (e) {
            this.mainLogger.error(`Error while registerCacheTopic`, e);
        }
    }
    async sendCorrespondingCachedAppData(topic, dataID, appData, cycle, fromId, txId) {
        try {
            if (this.config.p2p.useFactCorrespondingTell) {
                await this.stateManager.cachedAppDataManager.factSendCorrespondingCachedAppData(topic, dataID, appData, cycle, fromId, txId);
            }
            else {
                await this.stateManager.cachedAppDataManager.sendCorrespondingCachedAppData(topic, dataID, appData, cycle, fromId, txId);
            }
        }
        catch (e) {
            this.mainLogger.error(`Error while sendCorrespondingCachedAppData`, e);
        }
    }
    /**
     * This function is used to query data from an account that is guaranteed to be in a remote shard
     * @param {*} address The address / publicKey of the account in which to query
     */
    async getRemoteAccount(address) {
        return this.stateManager.getRemoteAccount(address);
    }
    getConsenusGroupForAccount(address) {
        return this.stateManager.transactionQueue.getConsenusGroupForAccount(address);
    }
    getRandomConsensusNodeForAccount(address) {
        return this.stateManager.transactionQueue.getRandomConsensusNodeForAccount(address);
    }
    isAccountRemote(address) {
        return this.stateManager.transactionQueue.isAccountRemote(address);
    }
    /**
     * test once at the given probability to fail.  If it fails, log the message and return true.  If it doesnt fail, return false.
     * @param failChance 0-1
     * @param debugName
     * @param key
     * @param message
     * @param verboseRequired
     * @returns
     */
    testFailChance(failChance, debugName, key, message, verboseRequired) {
        //MAIN-NET disable this.
        if (this.stateManager.testFailChance(failChance, debugName, key, message, verboseRequired)) {
            return true;
        }
        else {
            return false;
        }
    }
    async debugForeverLoop(tag) {
        this.debugForeverLoopCounter++;
        /* prettier-ignore */ this.stateManager.transactionQueue.setDebugSetLastAppAwait('debugForeverLoop' + tag);
        while (this.debugForeverLoopsEnabled) {
            await utils.sleep(1000);
        }
        /* prettier-ignore */ this.stateManager.transactionQueue.setDebugSetLastAppAwait('debugForeverLoop' + tag, TransactionQueue_1.DebugComplete.Completed);
    }
    setupDebugEndpoints() {
        Context.network.registerExternalGet('debug-toggle-foreverloop', debugMiddleware_1.isDebugModeMiddleware, (req, res) => {
            this.debugForeverLoopsEnabled = !this.debugForeverLoopsEnabled;
            //optionally check the query param set and use that instead
            if (req.query.set) {
                this.debugForeverLoopsEnabled = req.query.set === 'true';
            }
            res.json({ debugForeverLoopsEnabled: this.debugForeverLoopsEnabled });
        });
    }
    /**
     * Creates a wrapped response for formatting required by shardus
     * @param {*} accountId
     * @param {*} accountCreated
     * @param {*} hash
     * @param {*} timestamp
     * @param {*} fullData
     */
    createWrappedResponse(accountId, accountCreated, hash, timestamp, fullData) {
        // create and return the response object, it will default to full data.
        return {
            accountId,
            accountCreated,
            isPartial: false,
            stateId: hash,
            timestamp,
            data: fullData,
        };
    }
    /**
     * setPartialData
     * @param {Shardus.WrappedResponse} response
     * @param {any} partialData
     * @param {any} userTag
     */
    setPartialData(response, partialData, userTag) {
        // if the account was just created we have to do something special and ignore partial data
        if (response.accountCreated) {
            response.localCache = response.data;
            return;
        }
        response.isPartial = true;
        // otherwise we will convert this response to be using partial data
        response.localCache = response.data;
        response.data = partialData;
        response.userTag = userTag;
    }
    genericApplyPartialUpate(fullObject, updatedPartialObject) {
        const dataKeys = Object.keys(updatedPartialObject);
        for (const key of dataKeys) {
            fullObject[key] = updatedPartialObject[key];
        }
    }
    // ended up not using this yet:
    // async debugSetAccountState(wrappedResponse:ShardusTypes.WrappedResponse) {
    //   //set data. this will invoke the app to set data also
    //   await this.stateManager.checkAndSetAccountData([wrappedResponse], 'debugSetAccountState', false)
    // }
    /**
     * This is for a dapp to restore a bunch of account data in a debug situation.
     * This will call back into the dapp and instruct it to commit each account
     * This will also update shardus values.
     * There is a bug with re-updating the accounts copy db though.
     * @param accountCopies
     */
    async debugCommitAccountCopies(accountCopies) {
        await this.stateManager._commitAccountCopies(accountCopies);
    }
    async forwardAccounts(data) {
        await Archivers.forwardAccounts(data);
    }
    // Expose dev public key to verify things on the app
    getDevPublicKeys() {
        return (0, debug_1.getDevPublicKeys)();
    }
    // Expose dev public key to verify things on the app
    getDevPublicKey(keyName) {
        return (0, debug_1.getDevPublicKey)(keyName);
    }
    // Expose dev key with highest security level
    getDevPublicKeyMaxLevel(clearance) {
        return (0, debug_1.getDevPublicKeyMaxLevel)(clearance);
    }
    // Verify that the key is the dev key and has the required security level
    ensureKeySecurity(keyName, clearance) {
        return (0, debug_1.ensureKeySecurity)(keyName, clearance);
    }
    getMultisigPublicKeys() {
        return (0, debug_1.getMultisigPublicKeys)();
    }
    getMultisigPublicKey(key) {
        return (0, debug_1.getMultisigPublicKey)(key);
    }
    ensureMultisigKeySecurity(pubKey, level) {
        return (0, debug_1.ensureMultisigKeySecurity)(pubKey, level);
    }
    /**
     * Shutdown this node in the network
     * @param {boolean} exitProcess Exit the process when shutting down
     */
    async shutdown(exitProcess = true) {
        try {
            this.mainLogger.info('exitCleanly: shutdown');
            await this.exitHandler.exitCleanly(exitProcess);
            // consider if we want this.  it can help for debugging:
            // await this.exitHandler.exitUncleanly()
        }
        catch (e) {
            throw e;
        }
    }
    /**
     * Grab the SDK interface provided by the application for shardus
     * @param {App} application
     * @returns {App}
     */
    _getApplicationInterface(application) {
        if (logger_1.logFlags.debug)
            this.mainLogger.debug('Start of _getApplicationInterfaces()');
        const applicationInterfaceImpl = {};
        try {
            if (application == null) {
                // throw new Error('Invalid Application Instance')
                return null;
            }
            if (typeof application.isInternalTx === 'function') {
                applicationInterfaceImpl.isInternalTx = (tx) => application.isInternalTx(tx);
            }
            if (typeof application.validate === 'function') {
                applicationInterfaceImpl.validate = (inTx, appData) => application.validate(inTx, appData);
            }
            else if (typeof application.validateTxnFields === 'function') {
                /**
                 * Compatibility layer for Apps that use the old validateTxnFields fn
                 * instead of the new validate fn
                 */
                applicationInterfaceImpl.validate = (inTx, appData) => {
                    const oldResult = application.validateTxnFields(inTx, appData);
                    const newResult = {
                        success: oldResult.success,
                        reason: oldResult.reason,
                        status: oldResult.status,
                    };
                    return newResult;
                };
            }
            else {
                throw new Error('Missing required interface function. validate()');
            }
            if (typeof application.crack === 'function') {
                applicationInterfaceImpl.crack = (inTx, appData) => application.crack(inTx, appData);
            }
            else if (typeof application.getKeyFromTransaction === 'function' &&
                typeof application.validateTxnFields === 'function') {
                /**
                 * Compatibility layer for Apps that use the old getKeyFromTransaction
                 * fn instead of the new crack fn
                 */
                applicationInterfaceImpl.crack = (inTx) => {
                    const oldGetKeyFromTransactionResult = application.getKeyFromTransaction(inTx);
                    const oldValidateTxnFieldsResult = application.validateTxnFields(inTx, null);
                    const newResult = {
                        timestamp: oldValidateTxnFieldsResult.txnTimestamp,
                        id: this.crypto.hash(inTx),
                        keys: oldGetKeyFromTransactionResult,
                        shardusMemoryPatterns: null,
                    };
                    return newResult;
                };
            }
            else {
                throw new Error('Missing required interface function. validate()');
            }
            if (typeof application.txPreCrackData === 'function') {
                applicationInterfaceImpl.txPreCrackData = async (tx, appData) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.txPreCrackData', false);
                    let { status: success, reason } = await application.txPreCrackData(tx, appData);
                    this.profiler.scopedProfileSectionEnd('process-dapp.txPreCrackData');
                    return { status: success, reason };
                };
            }
            else {
                applicationInterfaceImpl.txPreCrackData = async function () {
                    return { status: true, reason: '' };
                };
            }
            if (typeof application.getTimestampFromTransaction === 'function') {
                applicationInterfaceImpl.getTimestampFromTransaction = (inTx, appData) => application.getTimestampFromTransaction(inTx, appData);
            }
            else {
                throw new Error('Missing requried interface function.getTimestampFromTransaction()');
            }
            if (typeof application.calculateTxId === 'function') {
                applicationInterfaceImpl.calculateTxId = (inTx) => application.calculateTxId(inTx);
            }
            else {
                throw new Error('Missing requried interface function.calculateTxId()');
            }
            if (typeof application.apply === 'function') {
                applicationInterfaceImpl.apply = (inTx, wrappedStates, appData) => application.apply(inTx, wrappedStates, appData);
            }
            else {
                throw new Error('Missing required interface function. apply()');
            }
            if (typeof application.transactionReceiptPass === 'function') {
                applicationInterfaceImpl.transactionReceiptPass = async (tx, wrappedStates, applyResponse, isExecutionGroup) => application.transactionReceiptPass(tx, wrappedStates, applyResponse, isExecutionGroup);
            }
            else {
                applicationInterfaceImpl.transactionReceiptPass = async function (_tx, _wrappedStates, _applyResponse, _isExecutionGroup) { };
            }
            if (typeof application.transactionReceiptFail === 'function') {
                applicationInterfaceImpl.transactionReceiptFail = async (tx, wrappedStates, applyResponse) => application.transactionReceiptFail(tx, wrappedStates, applyResponse);
            }
            else {
                applicationInterfaceImpl.transactionReceiptFail = async function (_tx, _wrappedStates, _applyResponse) { };
            }
            if (typeof application.updateAccountFull === 'function') {
                applicationInterfaceImpl.updateAccountFull = async (wrappedStates, localCache, applyResponse) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.updateAccountFull', false);
                    await application.updateAccountFull(wrappedStates, localCache, applyResponse);
                    this.profiler.scopedProfileSectionEnd('process-dapp.updateAccountFull');
                };
            }
            else {
                throw new Error('Missing required interface function. updateAccountFull()');
            }
            if (typeof application.updateAccountPartial === 'function') {
                applicationInterfaceImpl.updateAccountPartial = async (wrappedStates, localCache, applyResponse) => application.updateAccountPartial(wrappedStates, localCache, applyResponse);
            }
            else {
                throw new Error('Missing required interface function. updateAccountPartial()');
            }
            if (typeof application.getRelevantData === 'function') {
                applicationInterfaceImpl.getRelevantData = async (accountId, tx, appData) => application.getRelevantData(accountId, tx, appData);
            }
            else {
                throw new Error('Missing required interface function. getRelevantData()');
            }
            if (typeof application.getStateId === 'function') {
                applicationInterfaceImpl.getStateId = async (accountAddress, mustExist) => application.getStateId(accountAddress, mustExist);
            }
            else {
                if (logger_1.logFlags.debug)
                    this.mainLogger.debug('getStateId not used by global server');
            }
            if (typeof application.close === 'function') {
                applicationInterfaceImpl.close = async () => application.close();
            }
            else {
                throw new Error('Missing required interface function. close()');
            }
            // App.get_account_data (Acc_start, Acc_end, Max_records)
            // Provides the functionality defined for /get_accounts API
            // Max_records - limits the number of records returned
            if (typeof application.getAccountData === 'function') {
                applicationInterfaceImpl.getAccountData = async (accountStart, accountEnd, maxRecords) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.getAccountData', false);
                    const res = await application.getAccountData(accountStart, accountEnd, maxRecords);
                    this.profiler.scopedProfileSectionEnd('process-dapp.getAccountData');
                    return res;
                };
            }
            else {
                throw new Error('Missing required interface function. getAccountData()');
            }
            if (typeof application.getCachedRIAccountData === 'function') {
                applicationInterfaceImpl.getCachedRIAccountData = async (addressList) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.getCachedRIAccountData', false);
                    const res = await application.getCachedRIAccountData(addressList);
                    this.profiler.scopedProfileSectionEnd('process-dapp.getCachedRIAccountData');
                    return res;
                };
            }
            else {
                applicationInterfaceImpl.getCachedRIAccountData = async (_addressList) => {
                    return [];
                };
            }
            if (typeof application.setCachedRIAccountData === 'function') {
                applicationInterfaceImpl.setCachedRIAccountData = async (accountRecords) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.setCachedRIAccountData', false);
                    await application.setCachedRIAccountData(accountRecords);
                    this.profiler.scopedProfileSectionEnd('process-dapp.setCachedRIAccountData');
                };
            }
            else {
                applicationInterfaceImpl.setCachedRIAccountData = async (_accountRecords) => { };
            }
            if (typeof application.getAccountDataByRange === 'function') {
                applicationInterfaceImpl.getAccountDataByRange = async (accountStart, accountEnd, tsStart, tsEnd, maxRecords, offset, accountOffset) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.getAccountDataByRange', false);
                    const res = await application.getAccountDataByRange(accountStart, accountEnd, tsStart, tsEnd, maxRecords, offset, accountOffset);
                    this.profiler.scopedProfileSectionEnd('process-dapp.getAccountDataByRange');
                    return res;
                };
            }
            else {
                throw new Error('Missing required interface function. getAccountDataByRange()');
            }
            if (typeof application.calculateAccountHash === 'function') {
                applicationInterfaceImpl.calculateAccountHash = (account) => application.calculateAccountHash(account);
            }
            else {
                throw new Error('Missing required interface function. calculateAccountHash()');
            }
            // App.set_account_data (Acc_records)
            // Acc_records - as provided by App.get_accounts
            // Stores the records into the Accounts table if the hash of the Acc_data matches State_id
            // Returns a list of failed Acc_id
            if (typeof application.setAccountData === 'function') {
                applicationInterfaceImpl.setAccountData = async (accountRecords) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.setAccountData', false);
                    application.setAccountData(accountRecords);
                    this.profiler.scopedProfileSectionEnd('process-dapp.setAccountData');
                };
            }
            else {
                throw new Error('Missing required interface function. setAccountData()');
            }
            // pass array of account ids to this and it will delete the accounts
            if (typeof application.deleteAccountData === 'function') {
                applicationInterfaceImpl.deleteAccountData = async (addressList) => application.deleteAccountData(addressList);
            }
            else {
                throw new Error('Missing required interface function. deleteAccountData()');
            }
            if (typeof application.getAccountDataByList === 'function') {
                applicationInterfaceImpl.getAccountDataByList = async (addressList) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.getAccountDataByList', false);
                    const accData = await application.getAccountDataByList(addressList);
                    this.profiler.scopedProfileSectionEnd('process-dapp.getAccountDataByList');
                    return accData;
                };
            }
            else {
                throw new Error('Missing required interface function. getAccountDataByList()');
            }
            if (typeof application.getNetworkAccount === 'function') {
                applicationInterfaceImpl.getNetworkAccount = () => application.getNetworkAccount();
            }
            else {
                applicationInterfaceImpl.getNetworkAccount = () => null;
            }
            if (typeof application.deleteLocalAccountData === 'function') {
                applicationInterfaceImpl.deleteLocalAccountData = async () => {
                    this.profiler.scopedProfileSectionStart('process-dapp.deleteLocalAccountData', false);
                    await application.deleteLocalAccountData();
                    this.profiler.scopedProfileSectionEnd('process-dapp.deleteLocalAccountData');
                };
            }
            else {
                throw new Error('Missing required interface function. deleteLocalAccountData()');
            }
            if (typeof application.getAccountDebugValue === 'function') {
                applicationInterfaceImpl.getAccountDebugValue = (wrappedAccount) => application.getAccountDebugValue(wrappedAccount);
            }
            else {
                applicationInterfaceImpl.getAccountDebugValue = (_wrappedAccount) => 'getAccountDebugValue() missing on app';
            }
            //getSimpleTxDebugValue(tx)
            if (typeof application.getSimpleTxDebugValue === 'function') {
                applicationInterfaceImpl.getSimpleTxDebugValue = (tx) => application.getSimpleTxDebugValue(tx);
            }
            else {
                applicationInterfaceImpl.getSimpleTxDebugValue = (_tx) => '';
            }
            if (typeof application.canDebugDropTx === 'function') {
                applicationInterfaceImpl.canDebugDropTx = (tx) => application.canDebugDropTx(tx);
            }
            else {
                applicationInterfaceImpl.canDebugDropTx = (_tx) => true;
            }
            if (typeof application.sync === 'function') {
                applicationInterfaceImpl.sync = async () => {
                    this.profiler.scopedProfileSectionStart('process-dapp.sync', false);
                    const res = await application.sync();
                    this.profiler.scopedProfileSectionEnd('process-dapp.sync');
                    return res;
                };
            }
            else {
                const thisPtr = this;
                applicationInterfaceImpl.sync = async function () {
                    thisPtr.mainLogger.debug('no app.sync() function defined');
                };
            }
            if (typeof application.dataSummaryInit === 'function') {
                applicationInterfaceImpl.dataSummaryInit = async (blob, accountData) => application.dataSummaryInit(blob, accountData);
            }
            else {
                applicationInterfaceImpl.dataSummaryInit = async function (_blob, _accountData) { };
            }
            if (typeof application.dataSummaryUpdate === 'function') {
                applicationInterfaceImpl.dataSummaryUpdate = async (blob, accountDataBefore, accountDataAfter) => application.dataSummaryUpdate(blob, accountDataBefore, accountDataAfter);
            }
            else {
                applicationInterfaceImpl.dataSummaryUpdate = async function (_blob, _accountDataBefore, _accountDataAfter) { };
            }
            if (typeof application.txSummaryUpdate === 'function') {
                applicationInterfaceImpl.txSummaryUpdate = async (blob, tx, wrappedStates) => application.txSummaryUpdate(blob, tx, wrappedStates);
            }
            else {
                applicationInterfaceImpl.txSummaryUpdate = async function (_blob, _tx, _wrappedStates) { };
            }
            if (typeof application.getAccountTimestamp === 'function') {
                applicationInterfaceImpl.getAccountTimestamp = async (accountAddress, mustExist) => application.getAccountTimestamp(accountAddress, mustExist);
            }
            else {
                applicationInterfaceImpl.getAccountTimestamp = async function (_accountAddress, _mustExist) {
                    return 0;
                };
            }
            if (typeof application.getTimestampAndHashFromAccount === 'function') {
                applicationInterfaceImpl.getTimestampAndHashFromAccount = (account) => application.getTimestampAndHashFromAccount(account);
            }
            else {
                applicationInterfaceImpl.getTimestampAndHashFromAccount = function (_account) {
                    return {
                        timestamp: 0,
                        hash: 'getTimestampAndHashFromAccount not impl',
                    };
                };
            }
            if (typeof application.validateJoinRequest === 'function') {
                applicationInterfaceImpl.validateJoinRequest = (data, mode, latestCycle, minNodes) => application.validateJoinRequest(data, mode, latestCycle, minNodes);
            }
            if (typeof application.validateArchiverJoinRequest === 'function') {
                applicationInterfaceImpl.validateArchiverJoinRequest = (data) => application.validateArchiverJoinRequest(data);
            }
            if (typeof application.getJoinData === 'function') {
                applicationInterfaceImpl.getJoinData = () => application.getJoinData();
            }
            if (typeof application.eventNotify === 'function') {
                applicationInterfaceImpl.eventNotify = application.eventNotify;
            }
            if (typeof application.isReadyToJoin === 'function') {
                applicationInterfaceImpl.isReadyToJoin = async (latestCycle, publicKey, activeNodes, mode) => application.isReadyToJoin(latestCycle, publicKey, activeNodes, mode);
            }
            else {
                // If the app doesn't provide isReadyToJoin, assume it is always ready to join
                applicationInterfaceImpl.isReadyToJoin = async (_latestCycle, _publicKey, _activeNodes, _mode) => true;
            }
            if (typeof application.getNodeInfoAppData === 'function') {
                applicationInterfaceImpl.getNodeInfoAppData = () => application.getNodeInfoAppData();
            }
            else {
                // If the app doesn't provide getNodeInfoAppData, assume it returns empty obj
                applicationInterfaceImpl.getNodeInfoAppData = () => { };
            }
            if (typeof application.updateNetworkChangeQueue === 'function') {
                applicationInterfaceImpl.updateNetworkChangeQueue = async (account, appData) => application.updateNetworkChangeQueue(account, appData);
            }
            else {
                // If the app doesn't provide updateNetworkChangeQueue, just return empty arr
                applicationInterfaceImpl.updateNetworkChangeQueue = async (_account, _appData) => [];
            }
            if (typeof application.pruneNetworkChangeQueue === 'function') {
                applicationInterfaceImpl.pruneNetworkChangeQueue = async (account, cycle) => application.pruneNetworkChangeQueue(account, cycle);
            }
            else {
                // If the app doesn't provide pruneNetworkChangeQueue, just return empty arr
                applicationInterfaceImpl.pruneNetworkChangeQueue = async (_account, _cycle) => [];
            }
            if (typeof application.canStayOnStandby === 'function') {
                applicationInterfaceImpl.canStayOnStandby = (joinInfo) => application.canStayOnStandby(joinInfo);
            }
            if (typeof application.signAppData === 'function') {
                applicationInterfaceImpl.signAppData = async (type, hash, nodesToSign, appData) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.signAppData', false);
                    const res = await application.signAppData(type, hash, nodesToSign, appData);
                    this.profiler.scopedProfileSectionEnd('process-dapp.signAppData');
                    return res;
                };
            }
            if (typeof application.beforeStateAccountFilter === 'function') {
                applicationInterfaceImpl.beforeStateAccountFilter = application.beforeStateAccountFilter;
            }
            if (typeof application.binarySerializeObject === 'function') {
                applicationInterfaceImpl.binarySerializeObject = (identifier, obj) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.binarySerializeObject', false);
                    const res = application.binarySerializeObject(identifier, obj);
                    this.profiler.scopedProfileSectionEnd('process-dapp.binarySerializeObject');
                    return res;
                };
            }
            else {
                console.log('binarySerializeObject not implemented');
                applicationInterfaceImpl.binarySerializeObject = (_identifier, obj) => {
                    return Buffer.from(lib_types_1.Utils.safeStringify(obj), 'utf8');
                };
            }
            if (typeof application.binaryDeserializeObject === 'function') {
                applicationInterfaceImpl.binaryDeserializeObject = (identifier, buffer) => {
                    this.profiler.scopedProfileSectionStart('process-dapp.binaryDeserializeObject', false);
                    const res = application.binaryDeserializeObject(identifier, buffer);
                    this.profiler.scopedProfileSectionEnd('process-dapp.binaryDeserializeObject');
                    return res;
                };
            }
            else {
                console.log('binaryDeserializeObject not implemented');
                applicationInterfaceImpl.binaryDeserializeObject = (_identifier, buffer) => {
                    return lib_types_1.Utils.safeJsonParse(buffer.toString('utf8'));
                };
            }
            if (typeof application.getTxSenderAddress === 'function') {
                applicationInterfaceImpl.getTxSenderAddress = (tx) => application.getTxSenderAddress(tx);
            }
            if (typeof application.injectTxToConsensor === 'function') {
                applicationInterfaceImpl.injectTxToConsensor = (consensor, tx) => application.injectTxToConsensor(consensor, tx);
            }
            if (typeof application.getNonceFromTx === "function") {
                applicationInterfaceImpl.getNonceFromTx = (tx) => application.getNonceFromTx(tx);
            }
            if (typeof application.getAccountNonce === "function") {
                applicationInterfaceImpl.getAccountNonce = (accountId) => application.getAccountNonce(accountId);
            }
            if (typeof application.verifyMultiSigs === 'function') {
                applicationInterfaceImpl.verifyMultiSigs = (rawPayload, sigs, allowedPubkeys, minSigRequired, requiredSecurityLevel) => application.verifyMultiSigs(rawPayload, sigs, allowedPubkeys, minSigRequired, requiredSecurityLevel);
            }
            else {
                applicationInterfaceImpl.verifyMultiSigs = (_rawPayload, _sigs, _allowedPubkeys, _minSigRequired, _requiredSecurityLevel) => {
                    return true;
                };
            }
            if (typeof application.isNGT === 'function') {
                applicationInterfaceImpl.isNGT = (tx) => application.isNGT(tx);
            }
            if (typeof application.verifyAppJoinData === 'function') {
                applicationInterfaceImpl.verifyAppJoinData = (data) => application.verifyAppJoinData(data);
            }
            if (typeof application.getNetworkAccountFromArchiver === 'function') {
                applicationInterfaceImpl.getNetworkAccountFromArchiver = async () => application.getNetworkAccountFromArchiver();
            }
            else {
                // If the app doesn't provide getNetworkAccountFromArchiver, assume it returns empty obj
                applicationInterfaceImpl.getNetworkAccountFromArchiver = async () => {
                    return null;
                };
            }
        }
        catch (ex) {
            this.shardus_fatal(`getAppInterface_ex`, `Required application interface not implemented. Exception: ${ex}`);
            this.fatalLogger.fatal('_getApplicationInterface: ' + ex.name + ': ' + ex.message + ' at ' + ex.stack);
            throw new Error(ex);
        }
        if (logger_1.logFlags.debug)
            this.mainLogger.debug('End of _getApplicationInterfaces()');
        // At this point, we have validated all the fields so a cast is appropriate
        return applicationInterfaceImpl;
    }
    /**
     * Register the exit and config routes
     */
    _registerRoutes() {
        // DEBUG routes
        this.network.registerExternalPost('exit', debugMiddleware_1.isDebugModeMiddlewareHigh, async (_req, res) => {
            res.json({ success: true });
            await this.shutdown();
        });
        // TODO elevate security beyond high when we get multi sig.  or is that too slow when needed?
        this.network.registerExternalPost('exit-apop', debugMiddleware_1.isDebugModeMiddlewareHigh, async (_req, res) => {
            (0, Apoptosis_1.apoptosizeSelf)('Apoptosis called at exit-apop route', 'Node stopped by call to exit-apop route.');
            res.json({ success: true });
        });
        this.network.registerExternalGet('config', debugMiddleware_1.isDebugModeMiddlewareLow, async (_req, res) => {
            res.json({ config: this.config });
        });
        this.network.registerExternalGet('netconfig', async (_req, res) => {
            res.json({ config: CycleCreator_1.netConfig });
        });
        this.network.registerExternalGet('nodeInfo', async (req, res) => {
            let reportIntermediateStatus = req.query.reportIntermediateStatus === 'true';
            const nodeInfo = Self.getPublicNodeInfo(reportIntermediateStatus);
            const appData = this.app.getNodeInfoAppData();
            let result = { nodeInfo: { ...nodeInfo, appData } };
            if ((0, debug_2.isDebugMode)() && req.query.debug === 'true') {
                result.debug = {
                    queriedWhen: new Date().toISOString(),
                    //Note we can't convert to shardusGetTime because process.uptime() uses Date.now() internally
                    startedWhen: new Date(Date.now() - process.uptime() * 1000).toISOString(),
                    uptimeMins: Math.round((100 * process.uptime()) / 60) / 100,
                    pid: process.pid,
                    currentQuarter: CycleCreator.currentQuarter,
                    currentCycleMarker: CycleChain.getCurrentCycleMarker() ?? null,
                    newestCycle: CycleChain.getNewest() ?? null,
                    lostArchiversMap: state_1.lostArchiversMap,
                };
            }
            res.json(result);
        });
        this.network.registerExternalGet('joinInfo', debugMiddleware_1.isDebugModeMiddlewareMedium, async (_req, res) => {
            const nodeInfo = Self.getPublicNodeInfo(true);
            let result = {
                respondedWhen: new Date().toISOString(),
                //Note we can't convert to shardusGetTime because process.uptime() uses Date.now() internally
                startedWhen: new Date(Date.now() - process.uptime() * 1000).toISOString(),
                uptimeMins: Math.round((100 * process.uptime()) / 60) / 100,
                pid: process.pid,
                publicKey: nodeInfo.publicKey,
                id: nodeInfo.id,
                status: nodeInfo.status,
                currentQuarter: CycleCreator.currentQuarter,
                currentCycleMarker: CycleChain.getCurrentCycleMarker() ?? null,
                previousCycleMarker: CycleChain.getNewest()?.previous,
                getStandbyListHash: JoinV2.getStandbyListHash(),
                getLastHashedStandbyList: JoinV2.getLastHashedStandbyList(),
                getSortedStandbyNodeList: JoinV2.getSortedStandbyJoinRequests(),
            };
            res.json(deepReplace(result, undefined, '__undefined__'));
        });
        this.network.registerExternalGet('standby-list-debug', debugMiddleware_1.isDebugModeMiddlewareLow, async (_req, res) => {
            let getSortedStandbyNodeList = JoinV2.getSortedStandbyJoinRequests();
            let result = getSortedStandbyNodeList.map((node) => ({
                pubKey: node.nodeInfo.publicKey,
                ip: node.nodeInfo.externalIp,
                port: node.nodeInfo.externalPort,
            }));
            res.json(result);
        });
        this.network.registerExternalGet('status-history', debugMiddleware_1.isDebugModeMiddlewareLow, async (_req, res) => {
            let result = Self.getStatusHistoryCopy();
            res.json(deepReplace(result, undefined, '__undefined__'));
        });
        this.network.registerExternalGet('socketReport', debugMiddleware_1.isDebugModeMiddlewareLow, async (_req, res) => {
            res.json(await (0, debugUtils_1.getSocketReport)());
        });
        this.network.registerExternalGet('forceCycleSync', debugMiddleware_1.isDebugModeMiddleware, async (req, res) => {
            let enable = req.query.enable === 'true' || false;
            Context_1.config.p2p.hackForceCycleSyncComplete = enable;
            res.json(await (0, debugUtils_1.getSocketReport)());
        });
        this.network.registerExternalGet('calculate-fake-time-offset', debugMiddleware_1.isDebugModeMiddlewareHigh, async (req, res) => {
            const shift = req.query.shift ? parseInt(req.query.shift) : 0;
            const spread = req.query.spread ? parseInt(req.query.spread) : 0;
            const offset = (0, network_1.calculateFakeTimeOffset)(shift, spread);
            /* prettier-ignore */ this.mainLogger.debug({ message: "Calculated fakeTimeOffset", data: { shift, spread, offset } });
            res.json({ success: true });
        });
        this.network.registerExternalGet('clear-fake-time-offset', debugMiddleware_1.isDebugModeMiddlewareHigh, async (_req, res) => {
            const offset = (0, network_1.clearFakeTimeOffset)();
            /* prettier-ignore */ this.mainLogger.debug({ message: "Cleared fakeTimeOffset", data: { offset } });
            res.json({ success: true });
        });
        // this.p2p.registerInternal(
        //   'sign-app-data',
        //   async (
        //     payload: {
        //       type: string
        //       nodesToSign: string
        //       hash: string
        //       appData: any
        //     },
        //     respond: (arg0: any) => any
        //   ) => {
        //     const { type, nodesToSign, hash, appData } = payload
        //     const { success, signature } = await this.app.signAppData?.(type, hash, Number(nodesToSign), appData)
        //     await respond({ success, signature })
        //   }
        // )
        const signAppDataBinaryHandler = {
            name: InternalRouteEnum_1.InternalRouteEnum.binary_sign_app_data,
            // eslint-disable-next-line @typescript-eslint/no-unused-vars
            handler: async (payload, respond, header, _sign) => {
                const route = InternalRouteEnum_1.InternalRouteEnum.binary_sign_app_data;
                nestedCounters_1.nestedCountersInstance.countEvent('internal', route);
                this.profiler.scopedProfileSectionStart(route);
                const errorHandler = (errorType, opts) => (0, Helpers_2.requestErrorHandler)(route, errorType, header, opts);
                try {
                    const requestStream = (0, Helpers_2.getStreamWithTypeCheck)(payload, TypeIdentifierEnum_1.TypeIdentifierEnum.cSignAppDataReq);
                    if (!requestStream) {
                        errorHandler(RequestErrorEnum_1.RequestErrorEnum.InvalidRequest);
                        respond({ success: false, signature: { owner: '', sig: '' } }, SignAppDataResp_1.serializeSignAppDataResp);
                        return;
                    }
                    const request = (0, SignAppDataReq_1.deserializeSignAppDataReq)(requestStream);
                    const { type, nodesToSign, hash, appData } = request;
                    const { success, signature } = await this.app.signAppData?.(type, hash, Number(nodesToSign), appData);
                    const response = { success: success, signature: signature };
                    const errors = (0, Helpers_1.verifyPayload)(AJVSchemaEnum_1.AJVSchemaEnum.SignAppDataResp, response);
                    if (errors) {
                        throw new Error('AJV verification for SignAppDataResp failed');
                    }
                    respond(response, SignAppDataResp_1.serializeSignAppDataResp);
                }
                catch (err) {
                    nestedCounters_1.nestedCountersInstance.countEvent('internal', `${route}-exception`);
                    /* prettier-ignore */ if (logger_1.logFlags.error)
                        this.mainLogger.error(`${route}: Exception executing request: ${utils.errorToStringFull(err)}`);
                    respond({ success: false, signature: { owner: '', sig: '' } }, SignAppDataResp_1.serializeSignAppDataResp);
                }
                finally {
                    this.profiler.scopedProfileSectionEnd(route);
                }
            },
        };
        this.p2p.registerInternalBinary(signAppDataBinaryHandler.name, signAppDataBinaryHandler.handler);
        // FOR internal testing. NEEDS to be removed for security purposes
        this.network.registerExternalPost('testGlobalAccountTX', debugMiddleware_1.isDebugModeMiddleware, async (req, res) => {
            try {
                this.mainLogger.debug(`testGlobalAccountTX: req:${utils.stringifyReduce(req.body)}`);
                const tx = req.body.tx;
                this.put(tx, false, true);
                res.json({ success: true });
            }
            catch (ex) {
                this.mainLogger.debug('testGlobalAccountTX:' + ex.name + ': ' + ex.message + ' at ' + ex.stack);
                this.shardus_fatal(`registerExternalPost_ex`, 'testGlobalAccountTX:' + ex.name + ': ' + ex.message + ' at ' + ex.stack);
            }
        });
        this.network.registerExternalPost('testGlobalAccountTXSet', debugMiddleware_1.isDebugModeMiddleware, async (req, res) => {
            try {
                this.mainLogger.debug(`testGlobalAccountTXSet: req:${utils.stringifyReduce(req.body)}`);
                const tx = req.body.tx;
                this.put(tx, true, true);
                res.json({ success: true });
            }
            catch (ex) {
                this.mainLogger.debug('testGlobalAccountTXSet:' + ex.name + ': ' + ex.message + ' at ' + ex.stack);
                this.shardus_fatal(`registerExternalPost2_ex`, 'testGlobalAccountTXSet:' + ex.name + ': ' + ex.message + ' at ' + ex.stack);
            }
        });
    }
    /**
     * Registers exception handlers for "uncaughtException" and "unhandledRejection"
     */
    registerExceptionHandler() {
        const logFatalAndExit = (err) => {
            console.log('Encountered a fatal error. Check fatal log for details.');
            this.shardus_fatal(`unhandledRejection_ex_` + err.stack.substring(0, 100), 'unhandledRejection: ' + err.stack);
            // this.exitHandler.exitCleanly()
            // If the networks active node count is < some percentage of minNodes, don't exit on exceptions and log a counter instead
            if (Context_1.config.p2p.continueOnException === true) {
                const activeNodes = NodeList_1.activeByIdOrder;
                const minNodesToExit = Context_1.config.p2p.baselineNodes * Context_1.config.p2p.minNodesPerctToAllowExitOnException;
                if (activeNodes.length < minNodesToExit) {
                    // Log a counter to say node is not going to apoptosize
                    const msg = `Not enough active nodes to exit on exception. Active nodes: ${activeNodes.length}, minNodesToExit: ${minNodesToExit}, baselineNodes: ${Context_1.config.p2p.baselineNodes}, minNodesPerctToAllowExitOnException: ${Context_1.config.p2p.minNodesPerctToAllowExitOnException}`;
                    this.mainLogger.warn(msg);
                    nestedCounters_1.nestedCountersInstance.countEvent('continueOnException', msg);
                    return;
                }
            }
            this.mainLogger.info(`exitUncleanly: logFatalAndExit`);
            this.exitHandler.exitUncleanly('Unhandled Exception', err.message);
        };
        process.on('uncaughtException', (err) => {
            logFatalAndExit(err);
        });
        process.on('unhandledRejection', (err) => {
            logFatalAndExit(err);
        });
    }
    /**
     * Checks a transaction timestamp for expiration
     * deprecated
     * @param {number} timestamp
     */
    // _isTransactionTimestampExpired(timestamp) {
    //   // this.mainLogger.debug(`Start of _isTransactionTimestampExpired(${timestamp})`)
    //   let transactionExpired = false
    //   const txnExprationTime = this.config.transactionExpireTime
    //   const currNodeTimestamp = Date.now()
    //   const txnAge = currNodeTimestamp - timestamp
    //   if (logFlags.debug)
    //     this.mainLogger.debug(`Transaction Timestamp: ${timestamp} CurrNodeTimestamp: ${currNodeTimestamp}
    //   txnExprationTime: ${txnExprationTime}   TransactionAge: ${txnAge}`)
    //   // this.mainLogger.debug(`TransactionAge: ${txnAge}`)
    //   if (txnAge >= txnExprationTime * 1000) {
    //     this.fatalLogger.error('Transaction Expired')
    //     transactionExpired = true
    //   }
    //   // this.mainLogger.debug(`End of _isTransactionTimestampExpired(${timestamp})`)
    //   return transactionExpired
    // }
    async updateConfigChangeQueue(account, lastCycle_counter, updateNetworkAccount) {
        if (account == null)
            return;
        // @ts-ignore // TODO where is listOfChanges coming from here? I don't think it should exist on data
        let changes = account.data.listOfChanges;
        if (!changes || !Array.isArray(changes)) {
            //this may get logged if we have a changeListGlobalAccount that does not have config settings on it.
            //The fix is to let the dapp set the global account to use for this
            // this.mainLogger.error(
            //   `Invalid changes in global account ${changeListGlobalAccount}`
            // )
            return;
        }
        const activeConfigChanges = new Set();
        for (let change of changes) {
            //skip future changes
            if (change.cycle > lastCycle_counter) {
                continue;
            }
            const changeHash = this.crypto.hash(change);
            //skip handled changes
            if (this.appliedConfigChanges.has(changeHash)) {
                activeConfigChanges.add(changeHash);
                continue;
            }
            //apply this change
            this.appliedConfigChanges.add(changeHash);
            activeConfigChanges.add(changeHash);
            let changeObj = change.change;
            let appData = change.appData;
            // If there is initShutdown change, if the latest cycle is greater than the cycle of the change, then skip it
            if (changeObj['p2p'] && changeObj['p2p']['initShutdown'] && change.cycle !== lastCycle_counter)
                continue;
            //safe for early path
            this.patchObject(this.config, changeObj, appData);
            // should avoid using this early if we dont want to commit archiver state
            if (updateNetworkAccount) {
                const prunedData = await this.app.pruneNetworkChangeQueue(account, lastCycle_counter);
                await this.stateManager.checkAndSetAccountData(prunedData, 'global network account update', true);
            }
            if (appData) {
                const data = await this.app.updateNetworkChangeQueue(account, appData);
                // should avoid using this early if we dont want to commit archiver state
                if (updateNetworkAccount) {
                    await this.stateManager.checkAndSetAccountData(data, 'global network account update', true);
                }
            }
            //safe for early path
            this.p2p.configUpdated();
            //safe for early path
            this.loadDetection.configUpdated();
            //safe for early path
            this.rateLimiting.configUpdated();
        }
        if (activeConfigChanges.size > 0) {
            // clear the entries from appliedConfigChanges that are no longer in the changes list
            for (let changeHash of this.appliedConfigChanges) {
                if (!activeConfigChanges.has(changeHash)) {
                    this.appliedConfigChanges.delete(changeHash);
                }
            }
        }
    }
    patchObject(existingObject, changeObj, appData) {
        for (const [key, value] of Object.entries(changeObj)) {
            if (existingObject[key] != null) {
                /* handle dev key rotation where both keys and values are required */
                if (key === 'devPublicKeys' || key === 'multisigKeys') {
                    existingObject[key] = value;
                    this.mainLogger.info(`patched ${key} to ${value}`);
                }
                else if (typeof value === 'object') {
                    this.patchObject(existingObject[key], value, appData);
                }
                else {
                    existingObject[key] = value;
                    this.mainLogger.info(`patched ${key} to ${value}`);
                    nestedCounters_1.nestedCountersInstance.countEvent('config', `patched ${key} to ${value}`);
                }
            }
        }
    }
    /**
     * Do some periodic debug logic work
     * @param lastCycle
     */
    updateDebug(lastCycle) {
        if (lastCycle == null)
            return;
        let countEndpointStart = this.config?.debug?.countEndpointStart;
        let countEndpointStop = this.config?.debug?.countEndpointStop;
        if (countEndpointStart == null || countEndpointStart < 0) {
            return;
        }
        //reset counters
        if (countEndpointStart === lastCycle.counter) {
            //nestedCountersInstance.resetCounters()
            //nestedCountersInstance.resetRareCounters()
            profiler_1.profilerInstance.clearScopedTimes();
            if (countEndpointStop === -1 || countEndpointStop <= countEndpointStart || countEndpointStop == null) {
                this.config.debug.countEndpointStop = countEndpointStart + 2;
            }
        }
        if (countEndpointStop === lastCycle.counter && countEndpointStop != null) {
            //nestedCountersInstance.resetRareCounters()
            //convert a scoped report into rare counter report blob
            let scopedReport = profiler_1.profilerInstance.scopedTimesDataReport();
            scopedReport.cycle = lastCycle.counter;
            scopedReport.node = `${Self.ip}:${Self.port}`;
            scopedReport.id = utils.makeShortHash(Self.id);
            nestedCounters_1.nestedCountersInstance.countRareEvent('scopedTimeReport', lib_types_1.Utils.safeStringify(scopedReport));
        }
    }
    setGlobal(address, addressHash, value, when, source) {
        GlobalAccounts.setGlobal(address, addressHash, value, when, source);
    }
    getDebugModeMiddleware() {
        return debugMiddleware_1.isDebugModeMiddleware;
    }
    getDebugModeMiddlewareLow() {
        return debugMiddleware_1.isDebugModeMiddlewareLow;
    }
    getDebugModeMiddlewareMedium() {
        return debugMiddleware_1.isDebugModeMiddlewareMedium;
    }
    getDebugModeMiddlewareHigh() {
        return debugMiddleware_1.isDebugModeMiddlewareHigh;
    }
    getDebugModeMiddlewareMultiSig() {
        return debugMiddleware_1.isDebugModeMiddlewareMultiSig;
    }
    shardus_fatal(key, log, log2 = null) {
        nestedCounters_1.nestedCountersInstance.countEvent('fatal-log', key);
        if (log2 != null) {
            this.fatalLogger.fatal(log, log2);
        }
        else {
            this.fatalLogger.fatal(log);
        }
    }
    monitorEvent(category, name, count, message) {
        nestedCounters_1.nestedCountersInstance.countEvent(category, name, count);
        if (logger_1.logFlags.verbose) {
            this.mainLogger.info(`Event received with info: {
        eventCategory: ${category},
        eventName: ${name},
        eventMessage: ${count},
      }`);
        }
        this.statistics.countEvent(category, name, count, message);
    }
    setMemoryLimit(topic, cacheCountLimit) {
        this.stateManager.cachedAppDataManager.setMemoryLimit(topic, cacheCountLimit);
    }
    async getAppDataSignatures(type, hash, nodesToSign, appData, allowedBackupNodes = 0) {
        const closestNodesIds = this.getClosestNodes(hash, nodesToSign + allowedBackupNodes);
        const filterNodeIds = closestNodesIds.filter((id) => id !== Self.id);
        const closestNodes = filterNodeIds.map((nodeId) => this.p2p.state.getNode(nodeId));
        let responses = [];
        if (filterNodeIds.length > 0) {
            const groupPromiseResp = await (0, utils_1.groupResolvePromises)(closestNodes.map((node) => {
                // if (this.config.p2p.useBinarySerializedEndpoints && this.config.p2p.signAppDataBinary) {
                const request = {
                    type,
                    hash,
                    nodesToSign,
                    appData,
                };
                return this.p2p.askBinary(node, InternalRouteEnum_1.InternalRouteEnum.binary_sign_app_data, request, SignAppDataReq_1.serializeSignAppDataReq, SignAppDataResp_1.deserializeSignAppDataResp, {});
                // } else
                // return this.p2p.ask(node, 'sign-app-data', {
                //   type,
                //   hash,
                //   nodesToSign,
                //   appData,
                // })
            }), (res) => {
                if (res.success)
                    return true;
                return false;
            }, allowedBackupNodes, Math.min(nodesToSign, filterNodeIds.length));
            if (groupPromiseResp.success)
                responses = groupPromiseResp.wins;
            else
                return {
                    success: groupPromiseResp.success,
                    signatures: [],
                };
        }
        if (closestNodesIds.includes(Self.id)) {
            const { success, signature } = await this.app.signAppData?.(type, hash, Number(nodesToSign), appData);
            /* prettier-ignore */ if (logger_1.logFlags.p2pNonFatal && logger_1.logFlags.console)
                console.log(success, signature);
            responses = [...responses, ...[{ success, signature }]];
        }
        const signatures = responses.map(({ signature }) => signature);
        if (logger_1.logFlags.verbose)
            this.mainLogger.debug('Signatures for get signed app data request', signatures);
        return {
            success: true,
            signatures: signatures,
        };
    }
    isOnStandbyList(publicKey) {
        return JoinV2.isOnStandbyList(publicKey);
    }
}
function deepReplace(obj, find, replace) {
    if (Array.isArray(obj)) {
        for (let i = 0; i < obj.length; i++) {
            if (obj[i] === find) {
                obj[i] = replace;
            }
            else if (typeof obj[i] === 'object' && obj[i] !== null) {
                deepReplace(obj[i], find, replace);
            }
        }
    }
    else if (typeof obj === 'object' && obj !== null) {
        for (const key in obj) {
            if (obj[key] === find) {
                obj[key] = replace;
            }
            else if (typeof obj[key] === 'object' && obj[key] !== null) {
                deepReplace(obj[key], find, replace);
            }
        }
    }
    return obj;
}
// tslint:disable-next-line: no-default-export
exports.default = Shardus;
exports.ShardusTypes = __importStar(require("../shardus/shardus-types"));
//# sourceMappingURL=index.js.map