"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeGetAccountDataWithQueueHintsReq = exports.serializeGetAccountDataWithQueueHintsReq = void 0;
const Helpers_1 = require("./ajv/Helpers");
const AJVSchemaEnum_1 = require("./enum/AJVSchemaEnum");
const TypeIdentifierEnum_1 = require("./enum/TypeIdentifierEnum");
const cGetAccountDataWithQueueHintsReqVersion = 1;
function serializeGetAccountDataWithQueueHintsReq(stream, obj, root = false) {
    if (root) {
        stream.writeUInt16(TypeIdentifierEnum_1.TypeIdentifierEnum.cGetAccountDataWithQueueHintsReq);
    }
    stream.writeUInt8(cGetAccountDataWithQueueHintsReqVersion);
    stream.writeUInt32(obj.accountIds.length);
    for (const accountId of obj.accountIds) {
        stream.writeString(accountId);
    }
}
exports.serializeGetAccountDataWithQueueHintsReq = serializeGetAccountDataWithQueueHintsReq;
function deserializeGetAccountDataWithQueueHintsReq(stream) {
    const version = stream.readUInt8();
    if (version > cGetAccountDataWithQueueHintsReqVersion) {
        throw new Error('GetAccountDataWithQueueHintsReq version mismatch');
    }
    const length = stream.readUInt32();
    const accountIds = [];
    for (let i = 0; i < length; i++) {
        accountIds.push(stream.readString());
    }
    const errors = (0, Helpers_1.verifyPayload)(AJVSchemaEnum_1.AJVSchemaEnum.GetAccountDataWithQueueHintsReq, { accountIds });
    if (errors && errors.length > 0) {
        throw new Error('Data validation error');
    }
    return {
        accountIds,
    };
}
exports.deserializeGetAccountDataWithQueueHintsReq = deserializeGetAccountDataWithQueueHintsReq;
//# sourceMappingURL=GetAccountDataWithQueueHintsReq.js.map