"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGetAccountDataByHashesResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const WrappedData_1 = require("./WrappedData");
const schemaGetAccountDataByHashesResp = {
    type: 'object',
    properties: {
        accounts: {
            type: 'array',
            items: WrappedData_1.schemaWrappedData,
        },
        stateTableData: {
            type: 'array',
            items: {
                type: 'object',
                properties: {
                    accountId: { type: 'string' },
                    txId: { type: 'string' },
                    txTimestamp: { type: 'string' },
                    stateBefore: { type: 'string' },
                    stateAfter: { type: 'string' },
                },
                required: ['accountId', 'txId', 'txTimestamp', 'stateBefore', 'stateAfter'],
            },
        },
    },
    required: ['accounts', 'stateTableData'],
};
function initGetAccountDataByHashesResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGetAccountDataByHashesResp = initGetAccountDataByHashesResp;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)('GetAccountDataByHashesResp', schemaGetAccountDataByHashesResp);
}
//# sourceMappingURL=GetAccountDataByHashesResp.js.map