"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGetAccountDataRespSerializable = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const WrappedData_1 = require("./WrappedData");
const schemaGetAccountDataResp = {
    type: 'object',
    properties: {
        data: {
            type: 'object',
            properties: {
                wrappedAccounts: {
                    type: 'array',
                    items: WrappedData_1.schemaWrappedData,
                },
                lastUpdateNeeded: { type: 'boolean' },
                wrappedAccounts2: {
                    type: 'array',
                    items: WrappedData_1.schemaWrappedData,
                },
                highestTs: { type: 'number' },
                delta: { type: 'number' },
            },
            required: ['wrappedAccounts', 'lastUpdateNeeded', 'wrappedAccounts2', 'highestTs', 'delta'],
        },
        errors: {
            type: 'array',
            items: { type: 'string' },
        },
    },
    required: [],
};
function initGetAccountDataRespSerializable() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGetAccountDataRespSerializable = initGetAccountDataRespSerializable;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.GetAccountDataResp, schemaGetAccountDataResp);
}
//# sourceMappingURL=GetAccountDataResp.js.map