"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initLostReportReq = exports.schemaLostReportReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaLostReportReq = {
    type: 'object',
    properties: {
        target: { type: 'string' },
        checker: { type: 'string' },
        reporter: { type: 'string' },
        cycle: { type: 'number' },
        timestamp: { type: 'number' },
        requestId: { type: 'string' },
        sign: {
            type: 'object',
            properties: {
                owner: { type: 'string' },
                sig: { type: 'string' },
            },
            required: ['owner', 'sig'],
        },
        killother: { type: 'boolean' },
    },
    required: ['target', 'checker', 'reporter', 'cycle', 'timestamp', 'requestId', 'sign'],
};
function initLostReportReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initLostReportReq = initLostReportReq;
function addSchemaDependencies() {
    // No dependencies
}
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.LostReportReq, exports.schemaLostReportReq);
}
//# sourceMappingURL=LostReportReq.js.map