export declare const schemaSign: {
    type: string;
    properties: {
        owner: {
            type: string;
        };
        sig: {
            type: string;
        };
    };
    required: string[];
};
export declare const schemaAppliedVote: {
    type: string;
    properties: {
        txid: {
            type: string;
        };
        transaction_result: {
            type: string;
        };
        account_id: {
            type: string;
            items: {
                type: string;
            };
        };
        account_state_hash_after: {
            type: string;
            items: {
                type: string;
            };
        };
        account_state_hash_before: {
            type: string;
            items: {
                type: string;
            };
        };
        cant_apply: {
            type: string;
        };
        node_id: {
            type: string;
        };
        sign: {
            type: string;
            properties: {
                owner: {
                    type: string;
                };
                sig: {
                    type: string;
                };
            };
            required: string[];
        };
        app_data_hash: {
            type: string;
        };
    };
    required: string[];
};
export declare const schemaConfirmOrChallengeMessage: {
    type: string;
    properties: {
        message: {
            type: string;
        };
        nodeId: {
            type: string;
        };
        appliedVote: {
            type: string;
            properties: {
                txid: {
                    type: string;
                };
                transaction_result: {
                    type: string;
                };
                account_id: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                account_state_hash_after: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                account_state_hash_before: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                cant_apply: {
                    type: string;
                };
                node_id: {
                    type: string;
                };
                sign: {
                    type: string;
                    properties: {
                        owner: {
                            type: string;
                        };
                        sig: {
                            type: string;
                        };
                    };
                    required: string[];
                };
                app_data_hash: {
                    type: string;
                };
            };
            required: string[];
        };
        sign: {
            type: string;
            properties: {
                owner: {
                    type: string;
                };
                sig: {
                    type: string;
                };
            };
            required: string[];
        };
    };
    required: string[];
};
export declare const schemaProposal: {
    type: string;
    properties: {
        applied: {
            type: string;
        };
        cant_preApply: {
            type: string;
        };
        accountIDs: {
            type: string;
            items: {
                type: string;
            };
        };
        beforeStateHashes: {
            type: string;
            items: {
                type: string;
            };
        };
        afterStateHashes: {
            type: string;
            items: {
                type: string;
            };
        };
        appReceiptDataHash: {
            type: string;
        };
        txid: {
            type: string;
        };
    };
    required: string[];
};
export declare const schemaSignedReceipt: {
    type: string;
    properties: {
        proposal: {
            type: string;
            properties: {
                applied: {
                    type: string;
                };
                cant_preApply: {
                    type: string;
                };
                accountIDs: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                beforeStateHashes: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                afterStateHashes: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                appReceiptDataHash: {
                    type: string;
                };
                txid: {
                    type: string;
                };
            };
            required: string[];
        };
        proposalHash: {
            type: string;
        };
        signaturePack: {
            type: string;
            items: {
                type: string;
                properties: {
                    owner: {
                        type: string;
                    };
                    sig: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
        voteOffsets: {
            type: string;
            items: {
                type: string;
            };
        };
        sign: {
            type: string;
            properties: {
                owner: {
                    type: string;
                };
                sig: {
                    type: string;
                };
            };
            required: string[];
        };
    };
    required: string[];
};
export declare const schemaAccountRepairInstruction: {
    type: string;
    properties: {
        accountID: {
            type: string;
        };
        hash: {
            type: string;
        };
        txId: {
            type: string;
        };
        accountData: {
            type: string;
            properties: {
                accountId: {
                    type: string;
                };
                stateId: {
                    type: string;
                };
                data: {};
                timestamp: {
                    type: string;
                };
                syncData: {
                    anyOf: ({
                        type: string;
                        additionalProperties: boolean;
                    } | {
                        type: string;
                        additionalProperties?: undefined;
                    })[];
                };
            };
            required: string[];
        };
        targetNodeId: {
            type: string;
        };
        signedReceipt: {
            type: string;
            properties: {
                proposal: {
                    type: string;
                    properties: {
                        applied: {
                            type: string;
                        };
                        cant_preApply: {
                            type: string;
                        };
                        accountIDs: {
                            type: string;
                            items: {
                                type: string;
                            };
                        };
                        beforeStateHashes: {
                            type: string;
                            items: {
                                type: string;
                            };
                        };
                        afterStateHashes: {
                            type: string;
                            items: {
                                type: string;
                            };
                        };
                        appReceiptDataHash: {
                            type: string;
                        };
                        txid: {
                            type: string;
                        };
                    };
                    required: string[];
                };
                proposalHash: {
                    type: string;
                };
                signaturePack: {
                    type: string;
                    items: {
                        type: string;
                        properties: {
                            owner: {
                                type: string;
                            };
                            sig: {
                                type: string;
                            };
                        };
                        required: string[];
                    };
                };
                voteOffsets: {
                    type: string;
                    items: {
                        type: string;
                    };
                };
                sign: {
                    type: string;
                    properties: {
                        owner: {
                            type: string;
                        };
                        sig: {
                            type: string;
                        };
                    };
                    required: string[];
                };
            };
            required: string[];
        };
    };
    required: string[];
};
export declare const schemaRepairOOSAccountsReq: {
    type: string;
    properties: {
        repairInstructions: {
            type: string;
            items: {
                type: string;
                properties: {
                    accountID: {
                        type: string;
                    };
                    hash: {
                        type: string;
                    };
                    txId: {
                        type: string;
                    };
                    accountData: {
                        type: string;
                        properties: {
                            accountId: {
                                type: string;
                            };
                            stateId: {
                                type: string;
                            };
                            data: {};
                            timestamp: {
                                type: string;
                            };
                            syncData: {
                                anyOf: ({
                                    type: string;
                                    additionalProperties: boolean;
                                } | {
                                    type: string;
                                    additionalProperties?: undefined;
                                })[];
                            };
                        };
                        required: string[];
                    };
                    targetNodeId: {
                        type: string;
                    };
                    signedReceipt: {
                        type: string;
                        properties: {
                            proposal: {
                                type: string;
                                properties: {
                                    applied: {
                                        type: string;
                                    };
                                    cant_preApply: {
                                        type: string;
                                    };
                                    accountIDs: {
                                        type: string;
                                        items: {
                                            type: string;
                                        };
                                    };
                                    beforeStateHashes: {
                                        type: string;
                                        items: {
                                            type: string;
                                        };
                                    };
                                    afterStateHashes: {
                                        type: string;
                                        items: {
                                            type: string;
                                        };
                                    };
                                    appReceiptDataHash: {
                                        type: string;
                                    };
                                    txid: {
                                        type: string;
                                    };
                                };
                                required: string[];
                            };
                            proposalHash: {
                                type: string;
                            };
                            signaturePack: {
                                type: string;
                                items: {
                                    type: string;
                                    properties: {
                                        owner: {
                                            type: string;
                                        };
                                        sig: {
                                            type: string;
                                        };
                                    };
                                    required: string[];
                                };
                            };
                            voteOffsets: {
                                type: string;
                                items: {
                                    type: string;
                                };
                            };
                            sign: {
                                type: string;
                                properties: {
                                    owner: {
                                        type: string;
                                    };
                                    sig: {
                                        type: string;
                                    };
                                };
                                required: string[];
                            };
                        };
                        required: string[];
                    };
                };
                required: string[];
            };
        };
    };
    required: string[];
};
export declare function initRepairOOSAccountReq(): void;
