"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSignAppDataResp = exports.schemaSignAppDataResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaSignAppDataResp = {
    type: 'object',
    properties: {
        success: { type: 'boolean' },
        signature: {
            type: 'object',
            properties: {
                owner: { type: 'string' },
                sig: { type: 'string' },
            },
            required: ['owner', 'sig'],
        },
    },
    required: ['success', 'signature'],
    additionalProperties: false,
};
function initSignAppDataResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initSignAppDataResp = initSignAppDataResp;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.SignAppDataResp, exports.schemaSignAppDataResp);
}
//# sourceMappingURL=SignAppDataResp.js.map