"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWrappedDataFromQueueSerializable = exports.schemaWrappedDataFromQueueSerializable = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const WrappedData_1 = require("./WrappedData");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaWrappedDataFromQueueSerializable = {
    type: 'object',
    properties: {
        ...WrappedData_1.schemaWrappedData.properties,
        seenInQueue: { type: 'boolean' },
    },
    required: [...WrappedData_1.schemaWrappedData.required, 'seenInQueue'],
};
function initWrappedDataFromQueueSerializable() {
    addSchemaDependencies();
    addSchemas();
}
exports.initWrappedDataFromQueueSerializable = initWrappedDataFromQueueSerializable;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.WrappedDataFromQueueSerializable, exports.schemaWrappedDataFromQueueSerializable);
}
//# sourceMappingURL=WrappedDataFromQueueSerializable.js.map