"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWrappedDataResponse = exports.schemaWrappedDataResponse = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const WrappedData_1 = require("./WrappedData");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaWrappedDataResponse = {
    type: 'object',
    properties: {
        ...WrappedData_1.schemaWrappedData.properties,
        accountCreated: { type: 'boolean' },
        isPartial: { type: 'boolean' },
    },
    required: [...WrappedData_1.schemaWrappedData.required, 'accountCreated', 'isPartial'],
};
function initWrappedDataResponse() {
    addSchemaDependencies();
    addSchemas();
}
exports.initWrappedDataResponse = initWrappedDataResponse;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.WrappedDataResponse, exports.schemaWrappedDataResponse);
}
//# sourceMappingURL=WrappedDataResponse.js.map