"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTellRoute = exports.isAskRoute = exports.InternalRouteEnum = void 0;
var InternalRouteEnum;
(function (InternalRouteEnum) {
    InternalRouteEnum["apoptosize"] = "apoptosize";
    InternalRouteEnum["binary_broadcast_state"] = "binary/broadcast_state";
    InternalRouteEnum["binary_send_cachedAppData"] = "binary/send_cachedAppData";
    InternalRouteEnum["binary_get_account_data_with_queue_hints"] = "binary/get_account_data_with_queue_hints";
    InternalRouteEnum["binary_get_account_queue_count"] = "binary/get_account_queue_count";
    InternalRouteEnum["binary_get_account_data_by_list"] = "binary/get_account_data_by_list";
    InternalRouteEnum["binary_broadcast_finalstate"] = "binary/broadcast_finalstate";
    InternalRouteEnum["binary_get_account_data"] = "binary/get_account_data";
    InternalRouteEnum["binary_sync_trie_hashes"] = "binary/sync_trie_hashes";
    InternalRouteEnum["binary_compare_cert"] = "binary/compare_cert";
    InternalRouteEnum["binary_get_tx_timestamp"] = "binary/get_tx_timestamp";
    InternalRouteEnum["binary_get_trie_hashes"] = "binary/get_trie_hashes";
    InternalRouteEnum["binary_get_account_data_by_hashes"] = "binary/get_account_data_by_hashes";
    InternalRouteEnum["binary_spread_tx_to_group_syncing"] = "binary/spread_tx_to_group_syncing";
    InternalRouteEnum["binary_request_state_for_tx_post"] = "binary/request_state_for_tx_post";
    InternalRouteEnum["binary_make_receipt"] = "binary/make_receipt";
    InternalRouteEnum["binary_spread_appliedVoteHash"] = "binary/spread_applied_vote_hash";
    InternalRouteEnum["binary_get_globalaccountreport"] = "binary/get_globalaccountreport";
    InternalRouteEnum["binary_get_confirm_or_challenge"] = "binary/get_confirm_or_challenge";
    InternalRouteEnum["binary_sign_app_data"] = "binary/sign_app_data";
    InternalRouteEnum["binary_get_trie_account_hashes"] = "binary/get_trie_account_hashes";
    InternalRouteEnum["binary_get_cached_app_data"] = "binary/get_cached_app_data";
    InternalRouteEnum["binary_request_tx_and_state"] = "binary/request_tx_and_state";
    InternalRouteEnum["binary_request_tx_and_state_before"] = "binary/request_tx_and_state_before";
    InternalRouteEnum["binary_lost_archiver_investigate"] = "binary/lost_archiver_investigate";
    InternalRouteEnum["binary_request_state_for_tx"] = "binary/request_state_for_tx";
    InternalRouteEnum["binary_request_receipt_for_tx"] = "binary/request_receipt_for_tx";
    InternalRouteEnum["binary_get_applied_vote"] = "binary/get_applied_vote";
    InternalRouteEnum["binary_lost_report"] = "binary/lost_report";
    InternalRouteEnum["binary_gossip"] = "binary/gossip";
    InternalRouteEnum["binary_repair_oos_accounts"] = "binary/repair_oos_accounts";
    InternalRouteEnum["binary_poqo_send_receipt"] = "binary/poqo_send_receipt";
    InternalRouteEnum["binary_poqo_data_and_receipt"] = "binary/poqo_data_and_receipt";
    InternalRouteEnum["binary_poqo_send_vote"] = "binary/poqo_send_vote";
})(InternalRouteEnum = exports.InternalRouteEnum || (exports.InternalRouteEnum = {}));
const askRoutes = new Set([
    InternalRouteEnum.apoptosize,
    InternalRouteEnum.binary_get_account_data_with_queue_hints,
    InternalRouteEnum.binary_get_account_queue_count,
    InternalRouteEnum.binary_get_account_data_by_list,
    InternalRouteEnum.binary_get_account_data,
    InternalRouteEnum.binary_compare_cert,
    InternalRouteEnum.binary_get_tx_timestamp,
    InternalRouteEnum.binary_get_trie_hashes,
    InternalRouteEnum.binary_get_account_data_by_hashes,
    InternalRouteEnum.binary_request_state_for_tx_post,
    InternalRouteEnum.binary_get_globalaccountreport,
    InternalRouteEnum.binary_get_confirm_or_challenge,
    InternalRouteEnum.binary_sign_app_data,
    InternalRouteEnum.binary_get_trie_account_hashes,
    InternalRouteEnum.binary_get_cached_app_data,
    InternalRouteEnum.binary_request_tx_and_state,
    InternalRouteEnum.binary_request_state_for_tx,
    InternalRouteEnum.binary_request_receipt_for_tx,
    InternalRouteEnum.binary_get_applied_vote,
]);
function isAskRoute(route) {
    return askRoutes.has(route);
}
exports.isAskRoute = isAskRoute;
function isTellRoute(route) {
    return !isAskRoute(route) || route === InternalRouteEnum.apoptosize;
}
exports.isTellRoute = isTellRoute;
//# sourceMappingURL=InternalRouteEnum.js.map